/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.Vector;

/**
 *
 * @author Dmitry
 */
class Agreement {
    double price;
    double volume;
    double swu_volume;
    double eup_volume;
    short product;
    int type;
    int year;
    Vector<Double> historic_price;
    Vector<Double> historic_prioritet;
    Contract contract;
    
    Actor seller;
    Actor buyer;

    private Agreement(Contract c) {
        
        price = c.price;
        volume = c.volume;
        eup_volume = c.volume;
        swu_volume = c.en_volume;
        product = c.product;
        year= c.year;
        type = c.type;
        contract = c;
        seller = c.get_seller();
        buyer = c.get_buyer();
        historic_price = c.historic_price;
        historic_prioritet = c.historic_prioritet;
    }
    
    private Agreement(ContractSWUPK c, boolean is_pk) {
        if(is_pk) {
            price = c.pk_price;
            product = Contract.P_PK;
            seller = c.getPk_seller();
            volume = c.pk_volume;
        }else{
            price = c.en_price;
            product = Contract.P_SWU;
            seller = c.getEn_seller();
            volume = c.en_volume;
        }
        buyer = c.get_buyer();
        eup_volume = c.volume;
        swu_volume = c.en_volume;
        year= c.year;
        type = c.type;
        contract = c;
        
    }
    private Agreement() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    static Agreement create_agreement(Contract c){
        return new Agreement(c);
    }
    static Agreement[] create_agreement(ContractSWUPK c){
        Agreement[] aa = new Agreement[2];
        aa[0] = new Agreement(c, true);
        aa[1] = new Agreement(c, false);
        return aa;
    }


}
