/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Vector;

/**
 *
 * @author Dmitry
 */
public class Contract {
    static int global_id;
    int id;
    public short product;
      
    private Actor buyer;
    private Actor seller;
    private Actor current_owner;
       
    public double volume;
    public double en_volume;
    public double enrichment;
    public short level;
       
    private float seria;
    private Contract father;
    private ArrayList<Contract> sons = new ArrayList();
    private int[] cousins;
    private ArrayList<Contract> brothers;
       
    double price;
    double min_price;
    double marge;
    double eup_price = 0;
    double swu_price = 0;
    
    private float prioritet;
       
    int year; 
    static short stage = 0;
       
    private ArrayList<double[]> raiting_inputs = new ArrayList();
    
    public static final short P_OUP = 1;
    public static final short P_PK = 2;
    public static final short P_SWU = 3;
    public static final short P_MOX = 4;
    public static final short P_REMIX = 5;
    
    static final short LEVEL_W = -2; // Ждать
    static final short  LEVEL_H = -1; // Архив
    static final short  LEVEL_R = 0;// отмененные
    static final short  LEVEL_RR = -10;// отложенная отмена
    static final short  LEVEL_A = 1;// офферта
    static final short  LEVEL_B = 2;// ответ
    static final short  LEVEL_C = 3;// сторговка
    static final short  LEVEL_D = 4;// Ответ на строрговку
    static final short  LEVEL_F = 5;// финализация
    private Tender tender;
    
    public int type;
    static final int  SWU_PK = 1;// тип ЕРР+ПК
    static final int  EUP = 2;// тип ОУП
    static final int  MOX = 3;// тип МОКС
    static final int  PWR_MOX = 4;// тип МОКС
    static final int  PK_Solo = 5;// только ПК
    static final int  REMIX = 6;// только ПК
    private Reactor reactor;
    
    int reason = 0;
    static final int REASON_QUOTA = 1;
    static final int REASON_CAP = 2;
    static final int REASON_PK_YOK = 3;
    static final int REASON_UNKNOWN = 4;
    Vector<Double> historic_price = new Vector();
    Vector<Double> historic_prioritet = new Vector();
    Contract(){
        int i = global_id;
        id = i;
        global_id++;
    }

   
    
   boolean is_my_level(short lev){
      return  level == lev; 
   }
   
   void step(){
       stage++;
   }

    void set_tender(Tender tender) {
        this.tender = tender;
        tender.set_contract(this);
        tender.set_tbulletin(World.get_tbulletin());
    }

    void tender_tick() {
        if (this.level == LEVEL_H) {
            return;
        }
        
        this.tender.tick();
    }

    public void setRaiting_inputs(double[] raiting_inputs) {
        this.raiting_inputs.add(raiting_inputs);
    }

    public void setMin_price(double min_price) {
        this.min_price = min_price;
    }

    public Tender getTender() {
        return tender;
    }
    
    
    
    void set_buyer(Actor b) {
        this.buyer = b;
    }

    void set_seller(Actor s) {
       this.seller = s;
    }
    
    void set_current_owner(Actor s) {
       this.current_owner = s;
    }
    
    void set_reactor(Reactor r){
        this.reactor = r;
    }
    
    Actor get_seller() {
        return this.seller;
    }
    Actor get_buyer() {
         return this.buyer;
    }
    
    Actor get_current_owner() {
         return this.current_owner;
    }
    
    int get_id(){
        return this.id;
    }
    
    int get_type(){
        return this.type;
    }
    
    double get_volume(){
        return this.volume;
    }
        
    double get_price(){
        return this.price;
    }
    
    int get_dealYear(){
        return this.year;
    }
    
    int get_supplyYear(){
        return this.year;
    }
    
    void set_price(double price) {
        this.price = price;
    }

    Reactor get_reactor() {
        return this.reactor;
    }

    String get_product(){
        if (product == 1){
            return "EUP";
        }
        else if (product == 2){
            return "PK";
        }
        else if (product == 3){
            return "SWU";
        }
        else if (product == 4){
            return "MOX";
        }
        else if (product == Contract.P_REMIX){
            return "REMIX";
        }
        else{
            return "WRONG PRODUCT CODE";
        }
    } 
    
    void set_brothers(ArrayList<Contract> all_created_contracts) {
        // Исключить из списка себя
        // Запомнить список
       ArrayList<Contract> copy = (ArrayList<Contract>) all_created_contracts.clone();
       copy.remove(this);
       this.brothers = copy;
    }

    ArrayList<Contract> push_brothers() throws BrotherNotReadyException {
        //try  {
            ArrayList<Contract> n_list = new ArrayList();
            for (Contract brother : brothers) {
                if (brother.level != Contract.LEVEL_R){
                    if (brother.level == level){
                        n_list.add(brother);
                    }
                    else{
                        throw new BrotherNotReadyException("not all brothers are ready");
                    }
                }
            }
            return n_list;
       /* }
        catch(BrotherNotReadyException e){
            // 
            return new ArrayList();
        }*/
    }

    void go_to_seller() {
        tender.go_to_seller();
    }
    void cancel() {
      tender.cancel();  
    }
    void waitC(){
        tender.waitC();  
    }
    void wake_up(){
        // Проверка что контракт ждет
        if (this.level != Contract.LEVEL_W){
           if  (this.level == Contract.LEVEL_R){
               return;
           }else
           throw new UnsupportedOperationException("Contract is not waiting!");
        }
        // Просыпаем отца и отправляем его в стадию обработки контракта
        this.tender.wake_up();
        if (Tender.LOGGING)
        System.err.println("Contract " + id + " is waking up");
    }
    boolean consider_deal(double pr) {
        return tender.consider_deal(pr);
    }
    boolean can_consider_deal(double pr) {
        return tender.can_consider_deal(pr);
    }
    boolean is_active() {
        if (level != Contract.LEVEL_R){
            return true;
        }
        else{
            return false;
        }
    }

    void set_father(Contract c) {
       this.father = c;
    }

    public void setSon(Contract son) {
        this.sons.add(son);
    }

    public Contract getSon(int i) {
        return sons.get(i);
    }

    public ArrayList<Contract> getSons() {
        ArrayList<Contract> active_sons = new ArrayList<Contract>();
        sons.stream().filter((son) -> (son.level != Contract.LEVEL_R)).forEachOrdered((son) -> {
            active_sons.add(son);
        });
        return active_sons;       
    }
    public ArrayList<Contract> getAllSons() {

        return sons;       
    }
    
    public Contract getFather() {
        return father;
    }

    void check_RSons() {
        tender.check_Rsons();
    }

    public ArrayList<Contract> getBrothers() {
        return brothers;
    }
    
    public double getPrice() {
        return price;
    }

    Contract[] split() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    public LinkedHashMap<String, Object> getExcelImport(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        
        Eimport.put("id", id);
        Eimport.put("Год поставки", year);
        Eimport.put("Тип сделки", typeToString());
        Eimport.put("Продукт", prodToString());
        Eimport.put("Покупатель", buyer.getName());
        Eimport.put("Продавец", seller.getName());
        Eimport.put("Реактор", reactor.getName());
        Eimport.put("Объем продукта", volume);
        Eimport.put("Цена продукта", price);
        Eimport.put("Рейтинг контракта", historic_prioritet.lastElement());
        Eimport.put("Маржа", marge);
        Eimport.put("Предельная цена", min_price);
        Eimport.put("Итерация", historic_price.size());
        Eimport.put("EUP_price", eup_price);
        return Eimport;
    }
    
    String typeToString(){
        String str = new String();
        switch (type){
            case Contract.EUP: str = "ОУП"; break;
            case Contract.MOX: str = "МОКС"; break;
            case Contract.SWU_PK: str = "ЕРР+ПК"; break;
            case Contract.REMIX: str = "РЕМИКС"; break;
            case Contract.PK_Solo: str = "ПК"; break;
        }
        return str;
    }
    
    String prodToString(){
        String str = new String();
        switch (product){
            case Contract.P_OUP: str = "ОУП"; break;
            case Contract.P_MOX: str = "МОКС"; break;
            case Contract.P_SWU: str = "ЕРР"; break;
            case Contract.P_PK: str = "ПК"; break;
            case Contract.P_REMIX: str = "РЕМИКС"; break;
        }
        return str;
    }
    
    void set_marge_in_tender(double marge){
        if (this.product == Contract.EUP) {
            this.tender.setMarge(marge);
            }
    }

    void setMin_pk_price(double costl, double min_marge) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void setMin_pk_price(double i) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void setMarge(double marge) {
        this.marge = marge;
    }

    void setSWU_stat(double swu_price, double swu_volume) {
        this.swu_price = swu_price;
        this.en_volume = swu_volume;
        if (swu_price <0){
            System.err.println("SWU Price < 0");
        } 
        if (Double.isNaN(swu_price)){
            System.err.println("SWU Price is NaN");
        }
    }
}

class BrotherNotReadyException extends Exception{ 
    public BrotherNotReadyException(Throwable e) { 
        initCause(e); 
    } 

    public BrotherNotReadyException(String message) {
        super(message);
    }
    
} 