/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Vector;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ButtonGroup;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author z
 */
public class DemoGuiAgentProperties extends javax.swing.JFrame {
    
    /*private String EXCEL_RELATIONS_PATH = "./" + "polit_relation.xlsx"; 
    private String EXCEL_QUOTAS_PATH = "./" + "polit_relation.xlsx";
    private String EXCEL_LOGISTICS_PATH = "./" + "polit_relation.xlsx"; */
    private String[] PATHS = {"./" + "polit_relation.xlsx", "./" + "quotas.xlsx", "./" + "logistic.xlsx"}; // TODO: связать с какимито переменными из Scenario или т.п.
    
    static final double DEFAULT_RELATIONS = 5.0; 
    static final double DEFAULT_ONE_REGION_RELATIONS = 9.0; 
    static final double DEFAULT_SELF_RELATIONS = 10.0; 
    static final double DEFAULT_QUOTAS = Double.POSITIVE_INFINITY; 
    static final double DEFAULT_LOGISTIC = 0.0;  
    
     // мапы с инфой из excel
    private HashMap<String, HashMap<Integer,Double>> READED_RELATIONS;
    private HashMap<Short, HashMap<Integer, HashMap<String,Double>>> READED_LOG;
    private HashMap<Short, HashMap<String, HashMap<Integer,Double>>> READED_QUOTAS;
    
    private HashMap<String, Short> prodCodes = new HashMap<>();
    
    private Agent agent;
    private ArrayList<String> agents_names;
    private ArrayList<Agent> my_agents;
    private int num_agents;
    private int CURRENT_TYPE = -1;      // хранит выбранную кнопку RadioButton: отношения=1, квоты=2, логист.=3
    
    // основные буферные мапы
    private HashMap<String, HashMap<Integer,Double>> buf_rel;
    private HashMap<Short, HashMap<Integer, HashMap<String,Double>>> buf_log;
    private HashMap<Short, HashMap<String, HashMap<Integer,Double>>> buf_quota;

    ButtonGroup buttonGroup = new ButtonGroup();
    
    private ArrayList<JTable> tables = new ArrayList<>();
    private ArrayList<JScrollPane> scroll_panes = new ArrayList<>();
  
    public DemoGuiAgentProperties(Agent ag, ArrayList<String> agents_names, ArrayList<Agent> agents,
            HashMap<String, HashMap<Integer,Double>> readed_rel, HashMap<Short, HashMap<Integer, HashMap<String,Double>>> readed_log,
            HashMap<Short, HashMap<String, HashMap<Integer,Double>>> readed_qouta) {
        initComponents();
        this.agent = ag;
        this.agents_names = agents_names;
        this.my_agents = agents;
        this.num_agents = agents_names.size();           // число агентов всего ( с учетом ag)
        
        this.READED_LOG = readed_log;
        this.READED_QUOTAS = readed_qouta;
        this.READED_RELATIONS = readed_rel;
        
        if (this.agent.getRelations().isEmpty()){   //TODO: убрать проверку на empty??
            this.agent.initRelations(agents_names);
            this.buf_rel = (HashMap<String, HashMap<Integer, Double>>) this.agent.getRelations().clone();
        }else{
            this.buf_rel = (HashMap<String, HashMap<Integer, Double>>) this.agent.getRelations1().clone();
        }
        if (this.agent.getQuotas1().isEmpty()){
            this.agent.initQuotas(agents_names);
            this.buf_quota = (HashMap<Short, HashMap<String, HashMap<Integer, Double>>>) this.agent.getQuotas1().clone();
        }else{
            this.buf_quota = this.agent.getQuotas1();
        }
        if (this.agent.getLogistics1().isEmpty()){
            this.agent.initLogistics(agents_names);
            this.buf_log = (HashMap<Short, HashMap<Integer, HashMap<String, Double>>>) this.agent.getLogistics1().clone();
        }else{
            this.buf_log = (HashMap<Short, HashMap<Integer, HashMap<String, Double>>>) this.agent.getLogistics1().clone();
        }
        
        this.prodCodes.put("ОУП", Contract.P_OUP);
        this.prodCodes.put("ПК", Contract.P_PK);
        this.prodCodes.put("ЕРР", Contract.P_SWU);
        this.prodCodes.put("МОКС", Contract.P_MOX);

        
        this.setTitle("Статистика для "+ag.getName());
        outputAgent(ag);
        
        buttonGroup.add(jRadioButton1);
        buttonGroup.add(jRadioButton2);
        buttonGroup.add(jRadioButton3);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButton6 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jButton5 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setLocation(new java.awt.Point(100, 0));
        setResizable(false);

        jTabbedPane1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(993, 430));

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Выберите таблицу:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N

        jRadioButton1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton1.setText("Отношения");
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jRadioButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton2.setText("Квоты");
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        jRadioButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton3.setText("Логистическая стоимость");
        jRadioButton3.setToolTipText("");
        jRadioButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButton1)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jRadioButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jRadioButton3)
                .addContainerGap())
        );

        jButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton2.setText("Подтвердить изменения");
        jButton2.setPreferredSize(new java.awt.Dimension(240, 64));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton3.setText("Значения по-умолчанию");
        jButton3.setPreferredSize(new java.awt.Dimension(240, 64));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton4.setText("Отменить изменения");
        jButton4.setPreferredSize(new java.awt.Dimension(240, 64));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jScrollPane1.setBorder(null);
        jScrollPane1.setForeground(new java.awt.Color(240, 240, 240));
        jScrollPane1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N

        jTextArea1.setEditable(false);
        jTextArea1.setBackground(new java.awt.Color(240, 240, 240));
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);
        jTextArea1.setLineWrap(true);
        jTextArea1.setWrapStyleWord(true);

        jButton6.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton6.setText("Отменить все изменения");
        jButton6.setPreferredSize(new java.awt.Dimension(240, 64));
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Загрузка из файла:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N

        jTextField1.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N

        jButton5.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton5.setText("Загрузить из файла");
        jButton5.setPreferredSize(new java.awt.Dimension(240, 64));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton7.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton7.setText("Выбрать файл");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jButton7, javax.swing.GroupLayout.DEFAULT_SIZE, 255, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 253, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addComponent(jTextField1)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButton5, javax.swing.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
                    .addComponent(jButton7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 13, Short.MAX_VALUE))
        );

        jTextField1.setEditable(false);

        jMenu1.setText("Помощь");
        jMenu1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jMenu1MouseClicked(evt);
            }
        });
        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 247, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 247, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 247, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 247, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(10, 10, 10))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1176, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 898, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    //<editor-fold defaultstate="collapsed" desc="jRadioButton functions">    
    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        // table Relations
        if (this.jTabbedPane1.getComponentCount() > 0){
            saveChanges(this.jTabbedPane1, (JTable) ((JScrollPane)this.jTabbedPane1.getComponentAt(0)).getViewport().getView(), this.agent, this.CURRENT_TYPE);
        }
        createTabbedPane(this.agent, 1);
        this.CURRENT_TYPE = 1;
        this.jTextField1.setText(this.PATHS[this.CURRENT_TYPE-1]);
    }//GEN-LAST:event_jRadioButton1ActionPerformed

    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        // table Quota
        if (this.jTabbedPane1.getComponentCount() > 0){
            saveChanges(this.jTabbedPane1, (JTable) ((JScrollPane)this.jTabbedPane1.getComponentAt(0)).getViewport().getView(), this.agent, this.CURRENT_TYPE);
        }
        createTabbedPane(this.agent, 2);
        this.CURRENT_TYPE = 2;
        this.jTextField1.setText(this.PATHS[this.CURRENT_TYPE-1]);
    }//GEN-LAST:event_jRadioButton2ActionPerformed

    private void jRadioButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton3ActionPerformed
        // table Log.cost
        if (this.jTabbedPane1.getComponentCount() > 0){
            saveChanges(this.jTabbedPane1, (JTable) ((JScrollPane)this.jTabbedPane1.getComponentAt(0)).getViewport().getView(), this.agent, this.CURRENT_TYPE);
        }
        createTabbedPane(this.agent, 3);
        this.CURRENT_TYPE = 3;
        this.jTextField1.setText(this.PATHS[this.CURRENT_TYPE-1]);
    }//GEN-LAST:event_jRadioButton3ActionPerformed
         //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="jButton functions">    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // accept changes
        if (this.CURRENT_TYPE != -1){
            saveChanges(this.jTabbedPane1, (JTable) ((JScrollPane)this.jTabbedPane1.getComponentAt(0)).getViewport().getView(), this.agent, this.CURRENT_TYPE);
        }
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void set_agent_params(int ind, Agent agent, short prod, String agent_name, int yaer, double value){
        switch (ind){
            case 2:
                agent.setQuota(prod, agent_name, yaer, value);
                break;
            
            case 3:
                agent.setLogistic(prod, agent_name, yaer, value);
                break;
        }
    }
    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // default values
        switch(this.CURRENT_TYPE)
        {
            case 1:
                //this.agent.setRelation(buf_rel);
                initDefaultRelations(this.buf_rel, this.agents_names);
                break;
                
            case 2:
                //this.agent.setQuota(buf_quota);
                initDefaultQuotas(this.buf_quota, this.agents_names);
                break;
                
            case 3:
                //this.agent.setLogistic(buf_log);
                initDefaultLogistics(this.buf_log, this.agents_names);
                break;
        }
        createTabbedPane(this.agent, this.CURRENT_TYPE);
//        this.setVisible(false);
//        this.dispose();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // откат изменений
        switch(this.CURRENT_TYPE)
        {
            case 1:
                this.agent.setRelation(this.buf_rel);
                break;
                
            case 2:
                this.agent.setQuota(this.buf_quota);
                break;
                
            case 3:
                this.agent.setLogistic1(this.buf_log);
                break;
        }
        createTabbedPane(this.agent, this.CURRENT_TYPE);

    }//GEN-LAST:event_jButton4ActionPerformed

    private void jMenu1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenu1MouseClicked
        String msg = "Для просмотра и редактирования данных выберите таблицу.\n\n" +
                "Для изменения значения в ячейке:\n" +
                "1) выберите ячейку;\n" +
                "2) дважды кликните по этой ячейке;\n" +
                "3) измените значение;\n" +
                "4) нажмите Enter для сохранения данных в ячейке.\n";
        
        JOptionPane.showMessageDialog(new JPanel(), msg, "Помощь",
                    JOptionPane.PLAIN_MESSAGE, new javax.swing.ImageIcon("src/help-icon.png"));
    }//GEN-LAST:event_jMenu1MouseClicked

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // load from file TODO: сделать чтение в зависимости от типа таблицы (регионы - 0, агенты - 1)
        int tableType = 0;
        
        switch (tableType){
            case 0:
                readAndFillAgentsParamsByRegions(this.my_agents);
                break;
            case 1:
                readAndFillAgentsParamsByAgents(this.my_agents);
                break;
            
        }
          
        createTabbedPane(this.agent, CURRENT_TYPE); // updaaate!
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // decline all changes
        switch(this.CURRENT_TYPE)
        {
            case 1:
                this.agent.setRelation(this.READED_RELATIONS);
                this.buf_rel = this.READED_RELATIONS;
                break;
                
            case 2:
                this.agent.setQuota(this.READED_QUOTAS);
                this.buf_quota = this.READED_QUOTAS;
                break;
                
            case 3:
                this.agent.setLogistic1(this.READED_LOG);
                this.buf_log = this.READED_LOG;
                break;
        }
        createTabbedPane(this.agent, this.CURRENT_TYPE);

//        this.setVisible(false);
//        this.dispose();  
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // bd path
        int returnVal = this.jFileChooser1.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String path = this.jFileChooser1.getSelectedFile().getAbsolutePath();
            this.jTextField1.setText(path);
            
            this.PATHS[this.CURRENT_TYPE] = path;
        }
    }//GEN-LAST:event_jButton7ActionPerformed

    private void outputAgent(Agent ag){
        String msg = "Агент "+ ag.getName() + "\n\n";
        
        msg += "Операторы: \n";
        for (int i=0; i < ag.get_operators().size(); i++){
            msg += ag.get_operators().get(i).getName() + "\n";
        }
        
        msg += "\nПоставщики природного урана: \n";
        for (int i=0; i < ag.get_minings().size(); i++){
            msg += ag.get_minings().get(i).getName() + "\n";
        }
        
        msg += "\nОбогатительные предприятия: \n";
        for (int i=0; i < ag.get_enrichments().size(); i++){
            msg += ag.get_enrichments().get(i).getName() + "\n";
        }
        
        msg += "\nПоставщики МОКСа: \n";
        for (int i=0; i < ag.get_mox_suppliers().size(); i++){
            msg += ag.get_mox_suppliers().get(i).getName() + "\n";
        }

        this.jTextArea1.setText(msg);
    } 
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc=" Tabbed Pane ">

    // создание табоицы в соответствие с БУФЕРНЫМИ мапами
    public void createTabbedPane(Agent agent,int tab_num){
        // очистка от существующих таблиц
        jTabbedPane1.removeAll();
        
        // создание новых
        HashMap<String, Short> products = new HashMap<>();
        products.put("ОУП", Contract.P_OUP);
        products.put("ПК", Contract.P_PK);
        products.put("ЕРР", Contract.P_SWU);
        products.put("МОКС", Contract.P_MOX);
        //String[] names = {"ОУП", "ПК" ,"ЕРР","Мокс"}; //};
        switch (tab_num){
            case 1:
                // таблица Отношения
                clearArrays();
                fillTable(initTable(), this.buf_rel, tab_num); // agent.getRelations()
                jTabbedPane1.addTab("Текущий агент: "+agent.getName(), this.scroll_panes.get(this.scroll_panes.size()-1));//this.scroll_panes.get(this.scroll_panes.size()-1));
                break;
            
            case 2:   // таблица Квоты
                for (Map.Entry<String, Short> entry : products.entrySet()){
                    clearArrays();
                    fillTable(initTable(), this.buf_quota.get(entry.getValue()), tab_num); //agent.getQuotas(),
                    jTabbedPane1.addTab(entry.getKey(), this.scroll_panes.get(this.scroll_panes.size()-1));   // добавляем последний элемент из локального списка
                }
                break;
                
            case 3:   // таблица Лог.стоимость
                for (Map.Entry<String, Short> entry : products.entrySet()){
                    clearArrays();
                    fillTableLogistic(initTable(), this.buf_log.get(entry.getValue()), tab_num); //agent.getLogistics(),
                    jTabbedPane1.addTab(entry.getKey(), this.scroll_panes.get(this.scroll_panes.size()-1));   // добавляем последний элемент из локального списка
                }
                break;
                
            default:
                JOptionPane.showMessageDialog(new JPanel(), "Неверный код таблицы!", "Исключение!",
                    JOptionPane.ERROR_MESSAGE);
                break;
        }
 
    }
    
    // очистка массивов tables И scroll_panes
    private void clearArrays(){
        this.tables.clear();
        this.scroll_panes.clear();
    }
    
    // инициализирует таблицу и ее (также она будет послежняя в общем списке таблиц)
    private JTable initTable(){
        // инициализация
        JTable jTable1 = new JTable();
        jTable1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object[][]{
            },
            new String [] {
            }
        ) {
            Class[] types = new Class [] {
                };

        });
        
        //jTable1.setEnabled(false);
        jTable1.setRowHeight(25);
        jTable1.setRowSelectionAllowed(false);
        jTable1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

        JScrollPane jScrollPane1 = new JScrollPane();
        jScrollPane1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jScrollPane1.setViewportView(jTable1); 
        
        // добавление в локальный список таблиц
        this.tables.add(jTable1);
        this.scroll_panes.add(jScrollPane1);
        
        
        return jTable1;
    }
    
    private void saveChanges(JTabbedPane jTabbedPane1, JTable jTable, Agent agent, int tab_num){
        switch (tab_num){
            case 1:
                for (int j=1; j < jTable.getModel().getColumnCount(); j++){ // по всем столбцам таблицы единственной вкладки 0 (т.е. по годам)

                    int year = Integer.parseInt((String) jTable.getModel().getColumnName(j)) ;

                    for (int k=0; k < jTable.getModel().getRowCount(); k++){  // по всем строкам столбца
                        String agent_name = (String) jTable.getModel().getValueAt(k, 0);
                        double value =  Double.parseDouble(String.valueOf(jTable.getModel().getValueAt(k, j)));
                        agent.setRelation(agent_name, year, value);   
                    }
                }
                break;
                
            case 2:
            case 3:
                for (int i=0; i < jTabbedPane1.getTabCount(); i++){             // проход по всем ТЕКУЩИМ вкладкам

                    short prod = this.prodCodes.get(jTabbedPane1.getTitleAt(i));
                    
                    for (int j=1; j < jTable.getModel().getColumnCount(); j++){   // по всем столбцам таблицы вкладки (т.е. по годам)

                        int year = Integer.parseInt((String) jTable.getModel().getColumnName(j));

                        for (int k=0; k < jTable.getModel().getRowCount(); k++){  // по всем строкам столбца
                            String agent_name = (String) jTable.getModel().getValueAt(k, 0);
                            double value = Double.parseDouble( String.valueOf(jTable.getModel().getValueAt(k, j)));
                            set_agent_params(tab_num, agent, prod, agent_name, year, value);   
                        }
                    }
                }
                break;
             
            default:
                break;
        }
    }
     
    //<editor-fold defaultstate="collapsed" desc="заполнение fill Tables">
    // заподнение таблицы для HashMap<String, HashMap<Integer,Double>> (по столбцам)
    private void fillTable(JTable table, HashMap<String, HashMap<Integer,Double>> hashtab, int tab_num){
                      
            if (hashtab.isEmpty()){               // если таблица пустая, то ее надо создать, параллельно заполняя таблицу
                createHashMap(table, tab_num);
            }
            else{                       //  иначе просто заполнить
                DefaultTableModel model = (DefaultTableModel) table.getModel();

                if (! model.getDataVector().isEmpty()){
                    model.getDataVector().removeAllElements();
                }
                
                ArrayList<String> agents_list = new ArrayList(hashtab.keySet()) ;
                ArrayList<Integer> years_list = new ArrayList(hashtab.get(agents_list.get(0)).keySet());
                java.util.Collections.sort(years_list);
                
                // добавление 1й колонки
                model.addColumn("", agents_list.toArray());
                
                // добавление остальных колонок
                Vector column = new Vector(agents_list.size());
                for (int i=0; i < years_list.size(); i++){
                    // заполнение колонки
                    for (int j=0; j < agents_list.size(); j++){
                       switch (tab_num){
                           case 1:
                               column.add(j, hashtab.get(agents_list.get(j)).get(years_list.get(i))); // this.agent.getRelation(agents_list.get(j), years_list.get(i))
                               break;

                           case 2:
                               column.add(j, hashtab.get(agents_list.get(j)).get(years_list.get(i))); // this.agent.getQuota(agents_list.get(j), years_list.get(i))
                               break;
                       }   
                    }
                   
                    // добавление колонки
                    model.addColumn(String.valueOf(years_list.get(i)), column);
                    column.clear();
                }
            }
        }
    
    // заподнение таблицы для HashMap<Integer, HashMap<String,Double>> (по столбцам)
    private void fillTableLogistic(JTable table, HashMap<Integer, HashMap<String,Double>> hashtab, int tab_num){
            // TODO: сделать, чтобы отображались column_names
                      
            if (hashtab.isEmpty()){               // если таблица пустая, то ее надо создать, параллельно заполняя таблицу
                createHashMap(table, tab_num);
            }
            else{                       //  иначе просто заполнить
                DefaultTableModel model = (DefaultTableModel) table.getModel();

                if (! model.getDataVector().isEmpty()){
                    model.getDataVector().removeAllElements();
                }

                ArrayList<Integer> years_list = new ArrayList(hashtab.keySet()) ;
                ArrayList<String> agents_list = new ArrayList(hashtab.get(years_list.get(1)).keySet()) ;

                // добавление 1й колонки (агенты)
                model.addColumn("", agents_list.toArray());                     

                // добавление  остальных колонок
                for (int i=0; i < years_list.size(); i++){
                    Integer ind = years_list.get(i);
                    Vector column = new Vector(hashtab.get(ind).values());
                    model.addColumn(years_list.get(i).toString(), column);
                }
            }
        }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="заполнение default-величинами">
    public void initDefaultRelations(HashMap<String, HashMap<Integer,Double>> relations, ArrayList<String> agents_names){
        for (int i=0; i < agents_names.size(); i++){          
            for (int j=0; j < Time.years.length; j++){
                if (agents_names.get(i).equals(this.agent.getName())){
                    setItemInSIDMap(relations, agents_names.get(i), Time.years[j], 10.0);
                }
                else{
                    setItemInSIDMap(relations, agents_names.get(i), Time.years[j], DEFAULT_RELATIONS);
                }
            }                                           
        }
    } 
    
    public void initDefaultQuotas(HashMap<Short, HashMap<String, HashMap<Integer,Double>>> quotas, ArrayList<String> agents_names){
        short[] p_ids = {Contract.P_OUP, Contract.P_PK, Contract.P_SWU, Contract.P_MOX};
        
        for (int id=0; id < p_ids.length; id++){
            for (int i=0; i < agents_names.size(); i++){          
                for (int j=0; j < Time.years.length; j++){
                    setItemInSIDMap(quotas.get(p_ids[id]), agents_names.get(i), Time.years[j], DEFAULT_QUOTAS);
                }                                           
            }
        }
    } 
    
    public void initDefaultLogistics(HashMap<Short, HashMap<Integer, HashMap<String,Double>>> logistics, ArrayList<String> agents_names){
        short[] p_ids = {Contract.P_OUP, Contract.P_PK, Contract.P_SWU, Contract.P_MOX};
        
        for (int id=0; id < p_ids.length; id++){
            for (int i=0; i < Time.years.length; i++){          
                for (int j=0; j < agents_names.size(); j++){
                    setLogistic(logistics.get(p_ids[id]), agents_names.get(j), Time.years[i], DEFAULT_LOGISTIC);
                }                                           
            }
        }
    } 
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="заполнение HashMap'ов">
        public void setLogistic(HashMap<Integer, HashMap<String,Double>> logistics, String AgentName, int Year, double rel){
        if (logistics == null){
            System.out.println("Logistic in AgentsProperties is null!!!");
        }
        
        if (logistics.containsKey(Year)){
            HashMap<String, Double> YearHash = logistics.get(Year);
            if (YearHash.containsKey(AgentName)){
                YearHash.replace(AgentName, rel);
            }else{
                YearHash.put(AgentName, rel);
            }
        }else{
            HashMap<String, Double> newYear = new HashMap<String,Double>();
            newYear.put(AgentName, rel);
            logistics.put(Year, newYear);
        }
    }
    
        // add item to HashMap<String, HashMap<Integer,Double>> 
    public void setItemInSIDMap(HashMap<String, HashMap<Integer,Double>> mapa, String AgentName, int Year, double rel){
    if (mapa == null){
            System.out.println("Quotas in AgentsProperties is null!!!");
        }
        
        if (mapa.containsKey(AgentName)){
            HashMap<Integer, Double> AgentHash = mapa.get(AgentName);
            if (AgentHash.containsKey(Year)){
                AgentHash.replace(Year, rel);
            }else{
                AgentHash.put(Year, rel);
            }
        }else{
            HashMap<Integer, Double> newAgent = new HashMap<Integer,Double>();
            newAgent.put(Year, rel);
            mapa.put(AgentName, newAgent);
        }
    }
     //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="копирование HashMap'ов в буферные Map'ы">

    private static HashMap<Integer, HashMap<String,Double>> copyHashMap2(HashMap<Integer, HashMap<String,Double>> original){
        HashMap<Integer, HashMap<String,Double>> copy = new HashMap<Integer, HashMap<String,Double>>();
        for (Map.Entry<Integer, HashMap<String,Double>> entry : original.entrySet())
        {
            HashMap<String,Double> copypart = new HashMap<String,Double>();
                for (Map.Entry<String,Double> entrypart : entry.getValue().entrySet())
                    {
                        copypart.put(entrypart.getKey(), entrypart.getValue());
                    }


            copy.put(entry.getKey(),copypart);
        }
        return copy;
    }
    
    private static HashMap<String, HashMap<Integer,Double>> copyHashMap1(HashMap<String, HashMap<Integer,Double>> original){
        HashMap<String, HashMap<Integer,Double>> copy = new HashMap<String, HashMap<Integer,Double>>();
        for (Map.Entry<String, HashMap<Integer,Double>> entry : original.entrySet())
        {
            HashMap<Integer,Double> copypart = new HashMap<Integer,Double>();
                for (Map.Entry<Integer,Double> entrypart : entry.getValue().entrySet())
                    {
                        copypart.put(entrypart.getKey(), entrypart.getValue());
                    }


            copy.put(entry.getKey(),copypart);
        }
        return copy;
    }    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="ЗАПОЛНЕНИЕ HashMap значениями default - разве еще нужно? ">
    // или пусть будет на всякий случай?
    // создает HashMap для агента (значения берутся по умолчанию; заполнение таблицы по колонкам), если она null, и параллельно заполняет таблицу
    private void createHashMap(JTable table, int tab_num){
        DefaultTableModel model = (DefaultTableModel) table.getModel();

        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        // добавление 1й колонки
        for (int i=0; i < 1; i++){           
            Object[] column = new Object[this.num_agents];
            column[0] = "";
            for (int j=0; j < this.num_agents; j++){
                column[j] = this.agents_names.get(j);                      

            }

            model.addColumn("", column);
        }
        
        // добавление остальных колонок и параллельное заполнение HashMap у агента
        for (Map.Entry<String, Short> entry : this.prodCodes.entrySet()){
            for (int i=0; i < Time.years.length; i++){          
                Object[] column = new Object[this.num_agents];
                column[0] = String.valueOf(Time.years[i]);
                for (int j=0; j < this.num_agents; j++){
                    switch (tab_num){
                        case 1:
                            column[j] = DEFAULT_RELATIONS;
                            this.agent.setRelation((String)model.getValueAt(j, 0), Time.years[i], DEFAULT_RELATIONS);
                            break;
                        case 2:
                            column[j] = DEFAULT_QUOTAS; 
                            this.agent.setQuota(entry.getValue(), (String)model.getValueAt(j, 0), Time.years[i], DEFAULT_QUOTAS);
                            break;
                        case 3:
                            column[j] = DEFAULT_LOGISTIC; 
                            this.agent.setLogistic(entry.getValue(), (String)model.getValueAt(j, 0), Time.years[i], DEFAULT_LOGISTIC);
                            break;
                    }                                           
                }

                model.addColumn(String.valueOf(Time.years[i]), column);
            } 
        }
    }

    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="readAndFillAgentsParamsByRegions">   
    public void readAndFillAgentsParamsByRegions(ArrayList<Agent> my_agents){
        // read from ExcelByRegions and filling agents 

        switch (this.CURRENT_TYPE){
            case 1:
                readAndFillAgentsRelationsByRegions(this.buf_rel, my_agents, this.PATHS[0]);
                break;
               
            case 2:
                readAndFillAgentsQuotasByRegions(this.buf_quota, my_agents, this.prodCodes, this.PATHS[1]);
                break;
                
            case 3:
                readAndFillAgentsLogisticsByRegions(this.buf_log, my_agents, this.prodCodes, this.PATHS[2]);
                break; 
        }
    }
    
    private void readAndFillAgentsRelationsByRegions(HashMap<String, HashMap<Integer,Double>> rel, ArrayList<Agent> my_agents, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, Double>> mapa = new HashMap<>();
        try {
            mapa = el.readSheetFromExcel(0);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
      
        Agent ag1 = this.agent;
        String reg_name1 = ag1.getRegion().getName();

        for (int j=0; j < my_agents.size(); j++){
            Agent ag2 = my_agents.get(j);
            String reg_name2 = ag2.getRegion().getName();

            for (int k=0; k < Time.years.length; k++){
                if (reg_name1.equals(reg_name2)){
                    setRelation(rel, ag2.getName(), Time.years[k], DEFAULT_ONE_REGION_RELATIONS);    
                }
                else{
                   // System.err.println(ag2.getName() + " " + Time.years[k] + " " + mapa.get(reg_name1).get(reg_name2) + " " +reg_name1 + " "+ reg_name2);

                    setRelation(rel, ag2.getName(), Time.years[k], mapa.get(reg_name1).get(reg_name2));    
                }

                setRelation(rel, ag1.getName(), Time.years[k], DEFAULT_SELF_RELATIONS);    
            }
        }    
        this.READED_RELATIONS = (HashMap<String, HashMap<Integer, Double>>) rel.clone(); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
        

    }
    
    private void readAndFillAgentsQuotasByRegions(HashMap<Short, HashMap<String, HashMap<Integer,Double>>> q, 
                                        ArrayList<Agent> my_agents, HashMap<String, Short> products, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_QUOTAS);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, Short> entry : products.entrySet()){
           
            Agent ag1 = this.agent;
            String reg_name1 = ag1.getRegion().getName();

            for (int j=0; j < my_agents.size(); j++){
                Agent ag2 = my_agents.get(j);
                String reg_name2 = ag2.getRegion().getName();

                for (int k=0; k < Time.years.length; k++){
                    //System.err.println(ag2.getName() + " " + Time.years[k] + " " + mapa.get(entry.getKey()).get(reg_name1).get(reg_name2) + " " +reg_name1 + " "+ reg_name2);
                    setQuota(q, entry.getValue(), ag2.getName(), Time.years[k], mapa.get(entry.getKey()).get(reg_name1).get(reg_name2));    
                }
            }
            this.READED_QUOTAS = (HashMap<Short, HashMap<String, HashMap<Integer, Double>>>) q.clone(); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
            
        }
    }
    
    private void readAndFillAgentsLogisticsByRegions(HashMap<Short, HashMap<Integer, HashMap<String,Double>>> log, ArrayList<Agent> my_agents, HashMap<String, Short> products, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_LOGISTIC);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, Short> entry : products.entrySet()){
            
            Agent ag1 = this.agent;
            String reg_name1 = ag1.getRegion().getName();

            for (int j=0; j < my_agents.size(); j++){
                Agent ag2 = my_agents.get(j);
                String reg_name2 = ag2.getRegion().getName();

                for (int k=0; k < Time.years.length; k++){
                    setLogistic(log, entry.getValue(), ag2.getName(), Time.years[k], mapa.get(entry.getKey()).get(reg_name1).get(reg_name2));    
                }
            }
            this.READED_LOG = (HashMap<Short, HashMap<Integer, HashMap<String, Double>>>) log.clone(); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
            
        }
    }

    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="readAndFillAgentsParamsByAgents">   
    public void readAndFillAgentsParamsByAgents(ArrayList<Agent> my_agents){
        // read from ExcelByAgents and filling agents 
                
        // для удобства - мапы, отображающие продукты и позиции агентов
        HashMap<String, Integer> agentsMap = new HashMap<>();
        for (int i=0; i < my_agents.size(); i++){
            agentsMap.put(my_agents.get(i).getName(), i);            
        }
        
        // само заполнение
        switch (this.CURRENT_TYPE){
            case 1:
                readAndFillAgentsRelationsByAgents(this.buf_rel, my_agents, agentsMap, this.PATHS[0]);
                break;
               
            case 2:
                readAndFillAgentsQuotasByAgents(this.buf_quota, my_agents, agentsMap, this.prodCodes, this.PATHS[1]);
                break;
                
            case 3:
                readAndFillAgentsLogisticsByAgents(this.buf_log, my_agents, agentsMap, this.prodCodes, this.PATHS[2]);
                break; 
        }

    }
    
    private void readAndFillAgentsRelationsByAgents(HashMap<String, HashMap<Integer,Double>> rel,
                                ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap,  String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, Double>> mapa = new HashMap<>();
        try {
            mapa = el.readSheetFromExcel(0);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        HashMap<String,Double> ag1_entry = mapa.get(this.agent.getName());

            for (Map.Entry<String,Double> ag2_entry : ag1_entry.entrySet()){
               for (int i=0; i < Time.years.length; i++){
                    int ag1_pos = agentsMap.get(this.agent.getName());
                    setRelation(rel, ag2_entry.getKey(), Time.years[i], ag2_entry.getValue());
                }
            }
            this.READED_RELATIONS = (HashMap<String, HashMap<Integer, Double>>) rel.clone();
        
    }
    
    private void readAndFillAgentsQuotasByAgents(HashMap<Short, HashMap<String, HashMap<Integer,Double>>> q,
                    ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap, HashMap<String, Short> products, String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_QUOTAS);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, HashMap<String, HashMap<String, Double>>> prod_entry : mapa.entrySet()){
         
            HashMap<String,Double> ag1_entry = prod_entry.getValue().get(this.agent.getName());
            for (Map.Entry<String,Double> ag2_entry : ag1_entry.entrySet()){
               for (int j=0; j < Time.years.length; j++){
                    int ag1_pos = agentsMap.get(this.agent.getName());
                    setQuota(q, products.get(products.get(prod_entry.getKey())), ag2_entry.getKey(), Time.years[j], ag2_entry.getValue());
               }
            }
            
            this.READED_QUOTAS = (HashMap<Short, HashMap<String, HashMap<Integer, Double>>>) q.clone(); 
        }
    }
    
    private void readAndFillAgentsLogisticsByAgents(HashMap<Short, HashMap<Integer, HashMap<String,Double>>> log,
                    ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap, HashMap<String, Short> products, String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_LOGISTIC);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, HashMap<String, HashMap<String, Double>>> prod_entry : mapa.entrySet()){
            HashMap<String,Double> ag1_entry = prod_entry.getValue().get(this.agent.getName());

            for (Map.Entry<String,Double> ag2_entry : ag1_entry.entrySet()){
               for (int j=0; j < Time.years.length; j++){
                    int ag1_pos = agentsMap.get(this.agent.getName());
                    setLogistic(log, products.get(products.get(prod_entry.getKey())), ag2_entry.getKey(), Time.years[j], ag2_entry.getValue());
               }
            }
            
        }
        this.READED_LOG = (HashMap<Short, HashMap<Integer, HashMap<String, Double>>>) log.clone(); 
    }
    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="set Relations/Quotas/Logistic">   
    public void setRelation(HashMap<String, HashMap<Integer,Double>> relations, String AgentName, int Year, double rel){
                
        if (relations.containsKey(AgentName)){
            HashMap<Integer, Double> AgentHash = relations.get(AgentName);
            if (AgentHash.containsKey(Year)){
                AgentHash.replace(Year, rel);
            }else{
                AgentHash.put(Year, rel);
            }
        }else{
            HashMap<Integer, Double> newAgent = new HashMap<Integer,Double>();
            newAgent.put(Year, rel);
            relations.put(AgentName, newAgent);
        }
    }
    
    public void setQuota(HashMap<Short, HashMap<String, HashMap<Integer,Double>>> quotas, short p_id, String agentName, int year, double rel){

        if (quotas.containsKey(p_id)){
            HashMap<String, HashMap<Integer, Double>> agHash = quotas.get(p_id);
            if (agHash.containsKey(agentName)){
                HashMap<Integer, Double> yearHash = agHash.get(agentName);
                if (yearHash.containsKey(year)){
                    yearHash.replace(year, rel);
                }else{
                    yearHash.put(year, rel);
                }
            }else{
                HashMap<Integer, Double> newAgent = new HashMap<Integer,Double>();
                newAgent.put(year, rel);
                agHash.put(agentName, newAgent);
            }
        }
        else{
            HashMap<Integer, Double> newAgent = new HashMap<Integer,Double>();
            newAgent.put(year, rel);

            HashMap<String, HashMap<Integer, Double>> newProd = new HashMap<>();
            newProd.put(agentName, newAgent);

            quotas.put(p_id, newProd);
        }
    }
        
    public void setLogistic(HashMap<Short, HashMap<Integer, HashMap<String,Double>>> logistics, short p_id, String agentName, int year, double rel){

        if (logistics.containsKey(p_id)){
            HashMap<Integer, HashMap<String, Double>> yearHash = logistics.get(p_id);
            if (yearHash.containsKey(year)){
                HashMap<String, Double> agHash = yearHash.get(year);
                if (agHash.containsKey(agentName)){
                    agHash.replace(agentName, rel);
                }else{
                    agHash.put(agentName, rel);
                }
            }else{
                HashMap<String, Double> newYear = new HashMap<String,Double>();
                newYear.put(agentName, rel);
                yearHash.put(year, newYear);
            }
        }
        else{
            HashMap<String, Double> newAgent = new HashMap<String,Double>();
            newAgent.put(agentName, rel);
            
            HashMap<Integer, HashMap<String, Double>> newYear = new HashMap<>();
            newYear.put(year, newAgent);
                  
            logistics.put(p_id, newYear);
        }
    }
    //</editor-fold>
    
    //</editor-fold>
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
