/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import Graphic.LineChart;
import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
/**
 *
 * @author z
 */
public class DemoGuiArchive extends javax.swing.JFrame {

    private String EXCEL_FILE = "example_archive.xlsx";    // TODO: изменить?
    private String EXCEL_FILE_PATH = "./" + EXCEL_FILE; 
    
    private Contract lastContract = null;
    
    public DemoGuiArchive() {
        initComponents();
        
        jTextArea1.setEditable(false);
        
//        DefaultTreeSelectionModel sModel = new DefaultTreeSelectionModel();
//        sModel.setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
//        jTree1.setSelectionModel(sModel);
        
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("");
        DefaultTreeModel model = new DefaultTreeModel(root);
        this.jTree1.setModel(model);
        
        
        HashMap<Integer, HashMap<Actor,HashMap<Integer, Contract>>> original = ArchiveChain.getContractsMap();
        for (Map.Entry<Integer, HashMap<Actor,HashMap<Integer, Contract>>> entry1 : original.entrySet())
        {
            // HashMap<Actor,HashMap<Integer, Contract>>; keys-years ~ lvl 1
            DefaultMutableTreeNode root1 = new DefaultMutableTreeNode(entry1.getKey());

            for (Map.Entry<Actor,HashMap<Integer, Contract>> entry2 : entry1.getValue().entrySet()){
                // HashMap<Integer, Contract>; keys-buyer ~ lvl 2
                DefaultMutableTreeNode root2 = new DefaultMutableTreeNode(entry2.getKey());

                for (Map.Entry<Integer, Contract> entry3 : entry2.getValue().entrySet()){
                    // keys-contract_id ~ lvl 3
                    root2.add(new DefaultMutableTreeNode(entry3.getValue()));
                }

                root1.add(root2);
            }

            root.add(root1);
        }

        jTree1.expandRow(0);
       
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Выберите контракт:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel1.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N

        jTree1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("root");
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.setCellRenderer(new DefaultTreeCellRenderer(){
            @Override
            public java.awt.Component getTreeCellRendererComponent(javax.swing.JTree pTree,
                Object pValue, boolean pIsSelected, boolean pIsExpanded,
                boolean pIsLeaf, int pRow, boolean pHasFocus) {
                java.awt.Component component = super.getTreeCellRendererComponent(pTree,
                    pValue, pIsSelected, pIsExpanded, pIsLeaf, pRow, pHasFocus);
                try {
                    //                        ((javax.swing.JLabel) component).setText( ((DefaultMutableTreeNode)pValue).get );
                    //                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    DefaultMutableTreeNode node = (DefaultMutableTreeNode)pValue;
                    if (node.getUserObject() instanceof Integer){
                        ((javax.swing.JLabel) component).setText(String.valueOf(node.getUserObject()));
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Actor){
                        ((javax.swing.JLabel) component).setText( ((Actor)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Contract){
                        ((javax.swing.JLabel) component).setIcon(new javax.swing.ImageIcon("src/contract-icon.png"));
                        ((javax.swing.JLabel) component).setText(String.valueOf(((Contract)(node.getUserObject())).get_id()) );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                }
                catch(java.lang.ClassCastException e){
                    ((javax.swing.JLabel) component).setText(String.valueOf(pValue));
                    ((javax.swing.JLabel) component).setFont(pTree.getFont());
                }

                return component; 
            }   
        });
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane3.setViewportView(jTree1);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 252, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 625, Short.MAX_VALUE)
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Свойства контракта:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(879, 309));

        jScrollPane2.setFont(new java.awt.Font("Times New Roman", 0, 13)); // NOI18N

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane2.setViewportView(jTextArea1);

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(572, 342));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 399, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2))
        );

        jButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton2.setText("Удалить вкладки");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton3.setText("Экспорт в Excel");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 584, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 204, Short.MAX_VALUE)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton2)
                            .addComponent(jButton3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 618, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged

        try{
            switch (evt.getPath().getPathCount()){        
                case 0:                 // если это корень, то бежим отсюда, не оглядываясь
                    return;
                case 2:                                                 // если последний уровень в пути = 2, то Год заключения
                case 3:                                     // выбран какой-то из Акторов, То просто сбросим путь
                    Object[] pp = {""};
                    jTree1.setSelectionPath(new TreePath(pp));
                    return;

            }
            // иначе, это, 99,99%, Контракт и все хорошо
            // ошибка может возникнуть в этой строке, если там обычный String
            DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)evt.getPath().getLastPathComponent();
            if (selectedNode.getUserObject() instanceof Contract){
                this.lastContract = (Contract)selectedNode.getUserObject();
                
                printContractInfo(this.lastContract);
                showCharts(this.lastContract);
            }

        }
        
        catch (java.lang.ClassCastException e){
            // если этовсе же String
            jTextArea1.append("\n"+"Node"+" is selected\n");
        }

        finally{
            // обязательно сбрасываем путь!!!
            Object[] pp = {""};
            jTree1.setSelectionPath(new TreePath(pp));
        }

    }//GEN-LAST:event_jTree1ValueChanged

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // delete tabs
        if (this.lastContract != null){
            jTabbedPane1.removeAll();

            DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
            showCharts((Contract)selectedNode.getUserObject());
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // export to excel
        if (ArchiveChain.getContracts().isEmpty()){
            JOptionPane.showMessageDialog(new JPanel(),"Список Архивных контрактов пуст", "Пусто!",
                    JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        try {
            Function<Contract, LinkedHashMap> func = (cont)-> cont.getExcelImport();
            ExcelLoader<Contract> el = new ExcelLoader<>(EXCEL_FILE_PATH);
            el.writeIntoExcel(ArchiveChain.getContracts(), func, "Архивные контракты");
//            el.readRowFromExcel(1, "88");
            JOptionPane.showMessageDialog(new JPanel(),"Сохранено", "Готово!",
                    JOptionPane.INFORMATION_MESSAGE);
        } catch (IOException ex) {
            Logger.getLogger(DemoGuiArchive.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void printContractInfo(Contract selectedContract){
        try{
            jTextArea1.setText("");
            String msg = "Контракт "+selectedContract.get_id()+"\n\n";
            jTextArea1.append(msg);
            
            if (selectedContract.get_type() == 1){
                msg = "Тип торгов: "+ "ЕРР+ПК"  + "\n";
                jTextArea1.append(msg);
            }
            else if (selectedContract.get_type() == 2){
                msg = "Тип торгов: "+ "ОУП"  + "\n";
                jTextArea1.append(msg);
            }
            else if (selectedContract.get_type() == 3){
                msg = "Тип торгов: "+ "МОКС"  + "\n";
                jTextArea1.append(msg);
            }
            else{
                msg = "Тип торгов: "+ String.valueOf(selectedContract.get_type())  + "\n";
                jTextArea1.append(msg);
            }
            
            msg = "Покупатель: "+ selectedContract.get_buyer().getName() + "\n";
            jTextArea1.append(msg);
            msg = "Продавец: "+ selectedContract.get_seller().getName() + "\n";
            jTextArea1.append(msg);
            msg = "Реактор: "+ selectedContract.get_reactor().getName()+ "\n";
            jTextArea1.append(msg);            
            msg = "Продукт: "+ selectedContract.get_product() + "\n";
            jTextArea1.append(msg);
            msg = "Объем: "+ String.format("%.2f", selectedContract.get_volume()) + "\n";
            jTextArea1.append(msg);
            msg = "Стоимость = "+ String.format("%.2f", selectedContract.get_price()) + "\n";
            jTextArea1.append(msg);
            msg = "Год сделки: "+ String.valueOf(selectedContract.get_dealYear()) + "\n";
            msg += "Год доставки: "+ String.valueOf(selectedContract.get_supplyYear()) + "\n";

            jTextArea1.append(msg); 
        }
        catch (java.lang.NullPointerException e){
            jTextArea1.setText("ОШИБКА ПРИ ЧТЕНИИ ДАННЫХ О КОНТРАКТЕ");
       }
    }
 
    private void showCharts(Contract selectedContract){
        
        LineChart chart = new LineChart("", "Приоритет", "Стоимость");
        chart.addData("Контракт "+selectedContract.id, selectedContract.historic_prioritet, selectedContract.historic_price);
        chart.run(jTabbedPane1.getSize());

        jTabbedPane1.addTab("Контракт "+selectedContract.id, chart);
        jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);

    }
    
//    private void showCharts(Contract selectedContract){
//        jDesktopPane1.removeAll();
//        
//        LineChart chart = new LineChart("", "Приоритет", "Стоимость");
//        chart.addData("Контракт "+selectedContract.id, selectedContract.historic_prioritet, selectedContract.historic_price);
//  
//        final JInternalFrame frame = chart.createFrame(jDesktopPane1.getSize(), "Средняя стоимость");
//        jDesktopPane1.add(frame);
//        frame.pack();
//        frame.setVisible(true);
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
