/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.logging.Logger;

/**
 *
 * @author Dmitry
 */
public class Deposit {
    int id;
    Country country;
    Mining owner;
    int owner_id;
    double volume;
    String name;
    double capacity;
    double[] all_capacity;
    int[] status = new int[Time.years.length];
    
    public Deposit() {
    }

    public Deposit(Country country, double volume) {
        this.country = country;
        this.name = country.getName();
        this.volume = volume;
        status = new int[Time.years.length];
    }
    
    public Deposit(int id , String name, Country country, int owner_id, double volume, java.time.LocalDate start) {
        this.id = id;
        this.name = name;
        this.country = country;
        this.owner_id = owner_id;
        this.volume = volume;
        status = new int[Time.years.length];
        all_capacity = new double[Time.years.length];
        init_status(start);
    }
    
    public Deposit(int id , String name, Country country, int owner_id, double volume, java.time.LocalDate start, boolean foo) {
        this.id = id;
        this.name = name;
        this.country = country;
        this.owner_id = owner_id;
        this.volume = volume;
        all_capacity = new double[Time.years.length]; 
    }
    
    public Deposit(int id , String name, Country country, int owner_id, double volume, java.time.LocalDate start, double[] foo) {
        this.id = id;
        this.name = name;
        this.country = country;
        this.owner_id = owner_id;
        this.volume = volume;
        all_capacity = foo; 
        capacity = foo[0];
        
        init_status(start);
    }
    public boolean on(){
        return status[Time.iTime]==0 & status[Time.iTime + 1]==1;
    }
    
    public void setStatus(java.time.LocalDate start){
        init_status(start);
    }
    
    private void init_status(java.time.LocalDate start){
        for (int i=0; i < this.status.length; i++){
            if (Time.years[i] < start.getYear()) {
                this.status[i] = 0;
            }
            else{
                this.status[i] = 1;
            }
        }
    }

    public void setCountry(Country country) {
        this.country = country;
    }

    public void setVolume(double volume) {
        this.volume = volume;
    }

    public String getName(){
        return this.name;
    }
    
    public void setOwner(Mining owner) {
        this.owner = owner;
    }

    public Country getCountry() {
        return country;
    }

    public double getVolume() {
        return volume;
    }
    
    public Mining getOwner() {
        return this.owner;
    }

    void restore() {
        if(Time.iTime < (Time.lastTime-1)){
            capacity = all_capacity[Time.iTime +1];
            
        }
    }

    void upgrade() {
        double delta = capacity*(Mining.upgrade_rate);
        this.capacity = capacity + delta;
        for (int i = Time.iTime+1; i < Time.years.length; i++) {
            all_capacity[i] = all_capacity[i] + delta;
        }
    }
}
