/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;
import java.util.function.Consumer;

/**
 *
 * @author Dmitry
 */
public class Queue {

    static void form_queue(ArrayList<Actor> AllActors) {
        AllActors.forEach((Actor actor) -> actor.form_demand());
    }

    static void restore(ArrayList<Actor> AllActors) {
        AllActors.forEach((Actor actor) -> actor.restore());
        ArrayList<Operator> Operators = new ArrayList();
        AllActors.stream().filter(a -> a.getClass().equals(Operator.class)).forEachOrdered(a -> Operators.add((Operator) a));
        Operator.check_remix(Operators);
      
    }
    
    static void run(ArrayList<Actor> AllActors, DemoModule module){
        ArrayList<Actor> OrderedActors = new ArrayList();
        // Cначала закупаем уран для трейдеров
        /*module.trader.form_special_demands(1000, 2020);
        module.trader.form_special_demands(5000, 2021);//5//4
        module.trader.form_special_demands(6000, 2022);//6//5
        module.trader.form_special_demands(5000, 2023);
        module.trader.form_special_demands(5000, 2024);
        module.trader.form_special_demands(6000, 2025);
        module.trader.form_special_demands(10000, 2026);
        module.trader.form_special_demands(13000, 2027);
        module.trader.form_special_demands(15000, 2028);
        module.trader.form_special_demands(21000, 2029);
        module.trader.form_special_demands(13000, 2030);
        */
        AllActors.forEach((Actor actor) -> actor.form_remix_demand());
        module.exec(OrderedActors);
        System.err.println("Test Remix ready...");
        
        OrderedActors.add(module.trader);
        module.exec(OrderedActors);
        System.err.println("Trader ready...");
        // Первых запускаем Россию и реакторы российского дизайна
        Enrichment tvel = module.my_enrichments.stream().filter(op -> op.id == 171).findFirst().get();
        tvel.setPbase(Producer.PBASE_COST);
        OrderedActors = get_ordered_actors(AllActors, 13);
        module.exec(OrderedActors);
        tvel.setPbase(Producer.PBASE_PRICE);
        System.err.println("Russia ready...");
        AllActors.forEach((Actor actor) -> actor.form_ru_demand());
        module.exec(new ArrayList());
        System.err.println("Ru Design ready...");
        // Потом центральную Америку Россию
        OrderedActors = get_ordered_actors(AllActors, 12);
        module.exec(OrderedActors);
        System.err.println("South America ready...");
        // Теперь Китай
        OrderedActors = get_ordered_actors(AllActors, 4);
        module.exec(OrderedActors);
        System.err.println("China ready...");
        // Потом Европу
        int[] A = new int[3];
        A[0] = 5;A[1] = 6;A[2] = 7;
        OrderedActors = get_ordered_actors(AllActors, A);
        module.exec(OrderedActors);
        System.err.println("Europa ready...");
        // Теперь США
        OrderedActors = get_ordered_actors(AllActors, 14);
        module.exec(OrderedActors);
        System.err.println("Usa ready...");
        // Теперь Индия
        OrderedActors = get_ordered_actors(AllActors, 8);
        module.exec(OrderedActors);
        System.err.println("India ready...");
        // Все остальное
        A = new int[5];
        A[0] = 1;A[1] = 2;A[2] = 9;A[3] = 10;A[4] = 11;
        OrderedActors = get_ordered_actors(AllActors, A);
        module.exec(OrderedActors);
        System.err.println("Other ready...");
        
        module.exec_pk(module.my_enrichments);
        System.err.println("Enrichments ready...");
       // module.trader.form_special_demands(2000, 2021);
       // OrderedActors.add(module.trader);
       // module.exec(OrderedActors);
        System.err.println("All ready...");
    }

    private static ArrayList<Actor> get_ordered_actors(ArrayList<Actor> AllActors, int i) {
        ArrayList<Actor> OrderedActors = new ArrayList();
        AllActors.stream().filter(act -> act.getRegion().id ==i).forEachOrdered(act -> {
            OrderedActors.add((Actor) act);
        } );
        return OrderedActors;
    }
    
    private static ArrayList<Actor> get_ordered_actors(ArrayList<Actor> AllActors, int[] iD) {
        ArrayList<Actor> OrderedActors = new ArrayList();
        for (int i : iD) {
            Object[] Z = AllActors.stream().filter(act -> act.getRegion().id ==i).toArray();
            for (Object z : Z) {
                OrderedActors.add((Actor) z);
            }
            Z = null;
        }
        return OrderedActors;
    }

    static void retrade_crumbs(ArrayList<Actor> OrderedActors) {
        ArrayList<Operator> operators = new ArrayList<>();
        for (Actor OrderedActor : OrderedActors) {
            if(OrderedActor.getClass().equals(Operator.class))
                operators.add((Operator) OrderedActor);
        }
        
         for (Operator operator : operators){
             operator.form_crumbs_demand();
         }
        
    }
    
    static void retrade_pk_crumbs(ArrayList<Enrichment> OrderedActors) {

        for (Enrichment enr : OrderedActors){
             enr.form_crumbs_demand();
         }
    }
}
