/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;

/**
 *
 * @author Dmitry
 */
public class Statistic {



    
    Actor act;
    
    double[] revenue;
    double[] expenses;
    
    double[] pk_volume;
    double[] pk_price;
            
    double[] swu_volume;
    double[] swu_price;
    
    double[] eup_volume;
    double[] eup_price;
    
    double[] mox_volume;
    double[] mox_price;
    
    double[] remix_volume;
    double[] remix_price;
    
    double[] pk_needs;
    double[] eup_needs;
    double[] swu_needs;
    double[] mox_needs;
    double[] remix_needs;
    
    double[] deplited;
    double[] loaded;
    int[] reactors;
    
    double[] termal_capcity;
    double[] electric_capcity;
    
    double[] electrcity;
    
    HashMap<Integer, HashMap<String,Double>> eup;
    HashMap<Integer, HashMap<String,Double>> pk;
    HashMap<Integer, HashMap<String,Double>> mox;
    HashMap<Integer, HashMap<String,Double>> swu;
    HashMap<Integer, HashMap<String,Double>> remix;
    
    public int[] getReactors() {
        return reactors;
    }

    public double[] getPk_volume() {
        return pk_volume;
    }

    public double[] getPk_price() {
        return pk_price;
    }

    public double[] getSwu_volume() {
        return swu_volume;
    }

    public double[] getSwu_price() {
        return swu_price;
    }

    public double[] getEup_volume() {
        return eup_volume;
    }

    public double[] getEup_price() {
        return eup_price;
    }

    public double[] getMox_volume() {
        return mox_volume;
    }

    public double[] getMox_price() {
        return mox_price;
    }

    public double[] getPk_needs() {
        return pk_needs;
    }

    public double[] getEup_needs() {
        return eup_needs;
    }

    public double[] getSwu_needs() {
        return swu_needs;
    }

    public double[] getMox_needs() {
        return mox_needs;
    }

    public double[] getElectric_capcity() {
        return electric_capcity;
    }

    public double[] getElectrcity() {
        return electrcity;
    }

    public double[] getRevenue() {
        return revenue;
    }

    public void setRevenue(double[] revenue) {
        this.revenue = revenue;
    }

    public double[] getExpenses() {
        return expenses;
    }

    public void setExpenses(double[] expenses) {
        this.expenses = expenses;
    }
    
    public Statistic(Actor act) {
        this.act = act;
        
        revenue = new double[Time.years.length];
        expenses = new double[Time.years.length];
        
        pk_volume = new double[Time.years.length];
        pk_price = new double[Time.years.length];
        swu_volume = new double[Time.years.length];
        swu_price = new double[Time.years.length];
        eup_volume = new double[Time.years.length];
        eup_price = new double[Time.years.length];
        mox_volume = new double[Time.years.length];
        mox_price = new double[Time.years.length];
        remix_volume = new double[Time.years.length];
        remix_price = new double[Time.years.length];
        
        pk_needs = new double[Time.years.length];
        eup_needs = new double[Time.years.length];
        swu_needs = new double[Time.years.length];
        mox_needs = new double[Time.years.length];
        remix_needs = new double[Time.years.length];
        
        deplited = new double[Time.years.length];
        loaded = new double[Time.years.length];
        
        reactors = new int[Time.years.length];
        termal_capcity = new double[Time.years.length];
        electric_capcity = new double[Time.years.length];
        electrcity = new double[Time.years.length];
        
        
    }
    
    void write_detailed_vol_info(Agreement con){
        String key_name = con.seller.getName();
        int key_year = con.year;
        HashMap<Integer, HashMap<String, Double>> map;
        switch(con.product){
            case Contract.P_MOX: {
            map = mox;
                break;
            }
            case Contract.P_OUP: {
                map = eup;
                break;
            }
            case Contract.P_PK: {
                map = pk;
                break;
            }
            case Contract.P_SWU: {
                map = swu;
                break;
            }
            case Contract.P_REMIX: {
                map = remix;
                break;
            }
            default: throw new Error("Undefined type");
        }
        
        if(map.get(key_year).containsKey(key_name)){
            map.get(key_year).replace(key_name, map.get(key_year).get(key_name) + con.volume);
         }else{
             map.get(key_year).put(key_name, con.volume);
         }
    }
    
    
    void recalc_deals_stat(int year, short product){
        ArrayList<Agreement> all_agrs_p = act.purchases.get(year);
        ArrayList<Agreement> all_agrs_s = act.sales.get(year);
        // по логике один из них пустой
        ArrayList<Agreement> all_args0 = new ArrayList(all_agrs_p);
        all_args0.addAll(all_agrs_s);
        ArrayList<Agreement> all_args = new ArrayList();
        Object[] b = all_args0.stream().filter(a -> a.product == product).toArray();
        for (Object object : b) {
            all_args.add((Agreement) object);
        }
        b = null;
        double new_volume = 0;
        double new_revenue = 0;
        for (Agreement arg : all_args) {
            new_volume = new_volume + arg.volume;
            new_revenue = new_revenue + arg.volume*arg.price;
        }
        int f = DMath.Arithmetic.indexOf(Time.years, year);
        switch(product){
            case Contract.P_MOX: {
                mox_price[f] = new_revenue/new_volume;
                mox_volume[f] = new_volume;
                break;
            }
            case Contract.P_OUP: {
                eup_price[f] = new_revenue/new_volume;
                eup_volume[f] = new_volume;
                break;
            }
            case Contract.P_PK: {
                pk_price[f] = new_revenue/new_volume;
                pk_volume[f] = new_volume;
                break;
            }
            case Contract.P_SWU: {
                swu_price[f] = new_revenue/new_volume;
                swu_volume[f] = new_volume;
                break;
            }
            case Contract.P_REMIX: {
                remix_price[f] = new_revenue/new_volume;
                remix_volume[f] = new_volume;
                break;
            }
        }
    }
    
    static LinkedHashMap agregateOperatorDetailInfo(ArrayList<Operator> ops, short Product) {
        HashMap<Integer, HashMap<String, Double>> map;
        switch (Product){
            case Contract.P_MOX: return agregateOperatorDetailInfoMox(ops);
            case Contract.P_OUP: return agregateOperatorDetailInfoEup(ops);
            case Contract.P_SWU: return agregateOperatorDetailInfoSwu(ops);
            default: throw new Error("No such Product");
        }
    }
    
    static LinkedHashMap agregateOperatorDetailInfoMox(ArrayList<Operator> ops){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        Eimport.put("year", Time.years);
        if(ops.isEmpty())return Eimport;
        ArrayList<MoxSupplier> suppliers = ops.get(0).get_my_mox_supplier();
        for (MoxSupplier supplier : suppliers) {
            double[] supp_sum = new double[Time.years.length];
            for (int i = 0; i < Time.years.length; i++) {
                for (Operator op : ops) {
                    supp_sum[i] = supp_sum[i] + op.stats.mox.get(Time.years[i]).get(supplier.getName());
                }
            }
            Eimport.put(supplier.getName(), supp_sum);
        }
        return Eimport;
    }
    
    static LinkedHashMap agregateOperatorDetailInfoEup(ArrayList<Operator> ops){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        Eimport.put("year", Time.years);
        if(ops.isEmpty())return Eimport;
        ArrayList<Enrichment> suppliers = ops.get(0).get_my_eup_supplier();
        for (Enrichment supplier : suppliers) {
            double[] supp_sum = new double[Time.years.length];
            for (int i = 0; i < Time.years.length; i++) {
                supp_sum[i] = 0;
                for (Operator op : ops) {
                    supp_sum[i] = supp_sum[i] + op.stats.eup.get(Time.years[i]).get(supplier.getName());
                }
            }
            Eimport.put(supplier.getName(), supp_sum);
        }
        return Eimport;
    }
    
    static LinkedHashMap agregateOperatorDetailInfoSwu(ArrayList<Operator> ops){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        Eimport.put("year", Time.years);
        if(ops.isEmpty())return Eimport;
        ArrayList<Enrichment> suppliers = ops.get(0).get_my_swu_supplier();
        
        for (Enrichment supplier : suppliers) {
            double[] supp_sum = new double[Time.years.length];
            for (int i = 0; i < Time.years.length; i++) {
                supp_sum[i] = 0;
                for (Operator op : ops) {
                    supp_sum[i] = supp_sum[i] + op.stats.swu.get(Time.years[i]).get(supplier.getName());
                }
            }
            Eimport.put(supplier.getName(), supp_sum);
        }
        return Eimport;
    }
    
    static LinkedHashMap agregateOperator(ArrayList<Operator> ops) {
         LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>(); 
        
        
        double[] Lrevenue = new double[Time.years.length];
        double[] Lexpenses = new double[Time.years.length];    
        double[] Lpk_volume = new double[Time.years.length];
        double[] Lpk_price = new double[Time.years.length];
        double[] Lswu_volume = new double[Time.years.length];    
        double[] Lswu_price = new double[Time.years.length];
        double[] Leup_volume = new double[Time.years.length];
        double[] Leup_price = new double[Time.years.length];    
        double[] Lmox_volume = new double[Time.years.length];
        double[] Lmox_price = new double[Time.years.length];
        double[] Lremix_volume = new double[Time.years.length];
        double[] Lremix_price = new double[Time.years.length];
        double[] Lpk_needs = new double[Time.years.length];    
        double[] Leup_needs = new double[Time.years.length];
        double[] Lswu_needs = new double[Time.years.length];
        double[] Lmox_needs = new double[Time.years.length];    
        double[] Lreactors = new double[Time.years.length];
        double[] Ltermal_capcity = new double[Time.years.length];
        double[] Lelectric_capcity = new double[Time.years.length];
        double[] Lelectrcity = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Operator op : ops) {
                Lrevenue[i] = Lrevenue[i] + op.stats.revenue[i];
                Lexpenses[i] = Lexpenses[i] + op.stats.expenses[i];
                Lpk_volume[i] = Lpk_volume[i] + op.stats.pk_volume[i];
                Lpk_price[i] = Lpk_price[i] + op.stats.pk_price[i]*op.stats.pk_volume[i];
                Lswu_volume[i] = Lswu_volume[i] + op.stats.swu_volume[i];
                Lswu_price[i] = Lswu_price[i] + op.stats.swu_price[i]*op.stats.swu_volume[i];
                Leup_volume[i] = Leup_volume[i] + op.stats.eup_volume[i];
                Leup_price[i] = Leup_price[i] + op.stats.eup_price[i]*op.stats.eup_volume[i];
                Lmox_volume[i] = Lmox_volume[i] + op.stats.mox_volume[i];
                Lmox_price[i] = Lmox_price[i] + op.stats.mox_price[i]*op.stats.mox_volume[i];
                Lremix_volume[i] = Lremix_volume[i] + op.stats.remix_volume[i];
                Lremix_price[i] = Lremix_price[i] + op.stats.remix_price[i]*op.stats.remix_volume[i];
                Lpk_needs[i] = Lpk_needs[i] + op.stats.pk_needs[i];
                Leup_needs[i] = Leup_needs[i] + op.stats.eup_needs[i];
                Lswu_needs[i] = Lswu_needs[i] + op.stats.swu_needs[i];
                Lmox_needs[i] = Lmox_needs[i] + op.stats.mox_needs[i];
                Lreactors[i] = Lreactors[i] + op.stats.reactors[i];
                Ltermal_capcity[i] = Ltermal_capcity[i] + op.stats.termal_capcity[i];
                Lelectric_capcity[i] = Lelectric_capcity[i] + op.stats.electric_capcity[i];
                Lelectrcity[i] = Lelectrcity[i] + op.stats.electrcity[i];
            }
            Lswu_price[i] = Lswu_price[i] / Lswu_volume[i];
            Leup_price[i] = Leup_price[i]/ Leup_volume[i];
            Lmox_price[i] = Lmox_price[i] / Lmox_volume[i];
            Lpk_price[i] = Lpk_price[i]/ Lpk_volume[i];
        }
        Eimport.put("year", Time.years);
        Eimport.put("revenue", Lrevenue);
        Eimport.put("expenses", Lexpenses);
        Eimport.put("pk_volume", Lpk_volume);
        Eimport.put("pk_price", Lpk_price);
        Eimport.put("swu_volume", Lswu_volume);
        Eimport.put("swu_price", Lswu_price);
        Eimport.put("eup_volume", Leup_volume);
        Eimport.put("eup_price", Leup_price);
        Eimport.put("mox_volume", Lmox_volume);
        Eimport.put("mox_price", Lmox_price);
        Eimport.put("pk_needs", Lpk_needs);
        Eimport.put("eup_needs", Leup_needs);
        Eimport.put("swu_needs", Lswu_needs);
        Eimport.put("mox_needs", Lmox_needs);
        Eimport.put("reactors", Lreactors);
        Eimport.put("termal_capcity", Ltermal_capcity);
        Eimport.put("electric_capcity", Lelectric_capcity);
        Eimport.put("electrcity", Lelectrcity);
        return Eimport;
    }
    public LinkedHashMap<String, Object> assembleActorSet(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>(); 
        
        Eimport.put("year", Time.years);
        Eimport.put("revenue", this.revenue);
        Eimport.put("expenses", this.expenses);
        Eimport.put("pk_volume", this.pk_volume);
        Eimport.put("pk_price", this.pk_price);
        Eimport.put("swu_volume", this.swu_volume);
        Eimport.put("swu_price", this.swu_price);
        Eimport.put("eup_volume", this.eup_volume);
        Eimport.put("eup_price", this.eup_price);
        Eimport.put("mox_volume", this.mox_volume);
        Eimport.put("mox_price", this.mox_price);
        Eimport.put("remix_volume", this.remix_volume);
        Eimport.put("remix_price", this.remix_price);
        
        return Eimport;
    }
    
    public LinkedHashMap<String, Object> assembleOperatorSet(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>(); 
        
        Eimport.put("year", Time.years);
        Eimport.put("revenue", this.revenue);
        Eimport.put("expenses", this.expenses);
        Eimport.put("pk_volume", this.pk_volume);
        Eimport.put("pk_price", this.pk_price);
        Eimport.put("swu_volume", this.swu_volume);
        Eimport.put("swu_price", this.swu_price);
        Eimport.put("eup_volume", this.eup_volume);
        Eimport.put("eup_price", this.eup_price);
        Eimport.put("mox_volume", this.mox_volume);
        Eimport.put("mox_price", this.mox_price);
        Eimport.put("remix_volume", this.remix_volume);
        Eimport.put("remix_price", this.remix_price);
        
        Eimport.put("pk_needs", this.pk_needs);
        Eimport.put("eup_needs", this.eup_needs);
        Eimport.put("swu_needs", this.swu_needs);
        Eimport.put("mox_needs", this.mox_needs);
        Eimport.put("reactors", this.reactors);
        Eimport.put("termal_capcity", this.termal_capcity);
        Eimport.put("electric_capcity", this.electric_capcity);
        Eimport.put("electrcity", this.electrcity);
        
        return Eimport;
    }
    
    public LinkedHashMap<String, Object> assembleEnrichmentSet(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>(); 
        Enrichment en = (Enrichment) this.act;
        Eimport.put("year", Time.years);
        Eimport.put("revenue", this.revenue);
        Eimport.put("expenses", this.expenses);
        Eimport.put("pk_volume", this.pk_volume);
        Eimport.put("pk_price", this.pk_price);
        Eimport.put("swu_volume", this.swu_volume);
        Eimport.put("swu_price", this.swu_price);
        Eimport.put("eup_volume", this.eup_volume);
        Eimport.put("eup_price", this.eup_price);
        Eimport.put("mox_volume", this.mox_volume);
        Eimport.put("mox_price", this.mox_price);
        
        Eimport.put("deplited", this.deplited);
        Eimport.put("Optimal Tail", en.opt_tails);
        Eimport.put("Prod Tail", en.prod_tails);
        Eimport.put("hipp_capacities", en.hipp_capacities);
        return Eimport;
    }

    void setProdMaps() {
        eup = new HashMap<>();
        swu = new HashMap<>();
        pk = new HashMap<>();
        mox = new HashMap<>();
        remix = new HashMap<>();
        double defaultV = 0;
        for (int i = 0; i < Time.years.length; i++) {
            eup.put(Time.years[i], new HashMap<>());
            for (Enrichment enrichment : act.get_my_eup_supplier()) {
                eup.get(Time.years[i]).put(enrichment.getName(), defaultV);
            }
            swu.put(Time.years[i], new HashMap<>());
            for (Enrichment enrichment : act.get_my_swu_supplier()) {
                swu.get(Time.years[i]).put(enrichment.getName(), defaultV);
            }
            pk.put(Time.years[i], new HashMap<>());
            for (Mining mining : act.get_my_min_supplier()) {
                pk.get(Time.years[i]).put(mining.getName(), defaultV);
            }
            mox.put(Time.years[i], new HashMap<>());
            for (MoxSupplier moxS : act.get_my_mox_supplier() ) {
                mox.get(Time.years[i]).put(moxS.getName(), defaultV);
            }
            
            remix.put(Time.years[i], new HashMap<>());
            RemixSupplier RemSupplier = act.get_my_remix_supplier(); 
            remix.get(Time.years[i]).put(RemSupplier.getName(), defaultV);
            
        }
    }

    void recalc_buy_deals_stat(int year) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double get_pk_buy_price(int iTime) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double get_pk_buy_volume(int i) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double get_pk_balance(double storage_cost, double start_capacity) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    static double[] calc_sum_reactors(ArrayList<Operator> ops){
        double[] Lreactors = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Operator op : ops) {
                Lreactors[i] = Lreactors[i] + op.stats.reactors[i];
            }
        }
        return Lreactors;
    }
    
    static double[] calc_sum_el_capacity(ArrayList<Operator> ops){
        double[] Lelectric_capcity = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Operator op : ops) {
                Lelectric_capcity[i] = Lelectric_capcity[i] + op.stats.electric_capcity[i]/1000;
            }
        }
        return Lelectric_capcity;
    }
    
    static double[] calc_sum_pk_production(ArrayList<Mining> minings){
        double[] all_prods = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Mining mining : minings) {
                if( mining.getClass() == Mining.class){
                      all_prods[i] = all_prods[i] +  mining.stats.pk_volume[i]/1000; 
                }
            }
        }
        return all_prods;
    }
    
    static double[] calc_sum_eup_delivery(ArrayList<Enrichment> enrichments){
        double[] all_prods = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Enrichment enr : enrichments) {
                all_prods[i] = all_prods[i] +  enr.stats.eup_volume[i]; 
            }
        }
        return all_prods;
    }
    
    static double[] calc_sum_capacity(ArrayList<Enrichment> enrichments){
        double[] all_capacity = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Enrichment enr : enrichments) {
                all_capacity[i] = all_capacity[i] +  enr.all_capacity[i]; 
            }
        }
        return all_capacity;
    }
    
    static double[] calc_mean_pk_cost(ArrayList<Mining> minings){
        double[] all_capacity = new double[Time.years.length];
        double[] volume = new double[Time.years.length];
        double[] mean_cost = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Mining mining : minings) {
                if( mining.getClass() == Mining.class){
                      all_capacity[i] = all_capacity[i] +  mining.stats.pk_volume[i];
                      volume[i] = volume[i] + mining.stats.pk_volume[i]*mining.all_cost[i];
                }
                mean_cost[i] = volume[i]/all_capacity[i];
            }
        }
        return mean_cost;
    }
    
    static double[] calc_mean_swu_cost(ArrayList<Enrichment> enrichments){
        double[] all_capacity = new double[Time.years.length];
        double[] volume = new double[Time.years.length];
        double[] mean_cost = new double[Time.years.length];
        for (int i = 0; i < Time.lastTime; i++) {
            for (Enrichment enr : enrichments) {
                all_capacity[i] = all_capacity[i] +  enr.all_capacity[i];
                volume[i] = volume[i] + enr.all_capacity[i]*enr.all_cost[i];
            }
            mean_cost[i] = volume[i]/all_capacity[i];
        }
        return mean_cost;
    }
}

