/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.*;

/**
 *
 * @author Dmitry
 */
public class Actor {
    int id;
    private String name;
    
    double money;
    
    private Agent agent;
    private Region region;
    
    ArrayList<Reactor> reactors;
    
    public boolean has_demand;
    double threshold;
    
    public LinkedHashMap<Integer, ArrayList<Agreement>> sales;
    public LinkedHashMap<Integer, ArrayList<Agreement>> purchases;
    
    Statistic stats;
    public Actor(){
        sales = new LinkedHashMap<>();
        purchases = new LinkedHashMap<>();
        for (int year : Time.years) {
            sales.put(year, new ArrayList<>());
            purchases.put(year, new ArrayList<>());
        }
        stats = new Statistic(this);
    }
    
    /*
    public void add_contract(Contract new_contract){
        contracts.add(new_contract);
    }
            
    public void add_agreement(Agreement new_agreement){
        agreements.add(new_agreement);
    }
    
    public void delete_contract(Contract d_contract){
        contracts.remove(d_contract);
    }
    */
    public boolean has_contract(){
    
    return true;
    }
    /*        
    public void clear_contracts(){
        contracts.removeAll(contracts);
    }        
    */
    public void set_actor_params(int id, String name, Region region, Agent agent)
    {
        this.id = id;
        this.name = name;
        this.region = region;
        this.agent = agent;
        this.agent.add_actor(this);
    }
    
    public void set_actor_params(int id, String name, Region region)
    {
        this.id = id;
        this.name = name;
        this.region = region;
    }
    
    public void set_agent(Agent agent)
    {
        this.agent = agent;
        this.agent.add_actor(this);
    }
    
    public void form_demand(){};
    
    public void form_ru_demand(){};
    
    public void form_remix_demand(){};
    
    public void set_demands(){}
    
    void restore() {
        
    }
    
    public ArrayList<MoxSupplier> get_my_mox_supplier()
    {
        ArrayList<MoxSupplier> ms = this.agent.get_mox_supplier();
        return ms;
    }
    
    ArrayList<Enrichment> get_my_eup_supplier() {
        ArrayList<Enrichment> es = this.agent.get_eup_supplier();
        return es;
    }
    ArrayList<Enrichment> get_my_rus_eup_supplier() {
        ArrayList<Enrichment> es = this.agent.get_rus_eup_supplier();
        return es;
    }
    ArrayList<Enrichment> get_my_eup_supplier(double need) {
        ArrayList<Enrichment> es = this.agent.get_eup_supplier(need);
        return es;
    }
    ArrayList<Mining> get_my_min_supplier() {
        ArrayList<Mining> min = this.agent.get_min_supplier();
        return min;
    }
    
    ArrayList<Mining> get_my_min_supplier(double need) {
        ArrayList<Mining> min = this.agent.get_min_supplier(need);
        return min;
    }
    
    ArrayList<Enrichment> get_my_swu_supplier() {
        ArrayList<Enrichment> es = getAgent().get_swu_supplier();
        return es;
    }
    
    ArrayList<Enrichment> get_my_swu_supplier(double need) {
        ArrayList<Enrichment> es = getAgent().get_swu_supplier(need);
        return es;
    }
    RemixSupplier get_my_remix_supplier() {
        return getAgent().get_remix_supplier();
    }
    boolean check_capacity(double volume) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double calc_marge(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    double calc_marge(ContractSWUPK c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    double calc_price(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    double calc_price(ContractSWUPK c){
        throw new UnsupportedOperationException("Реализация в подклассе");
    }
    double calc_prioritet(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    boolean is_acceptаble(double p) {
       return p>=this.threshold;
    }
    
    boolean is_acceptаble(Contract W) {
       throw new UnsupportedOperationException("Only for Operators");
    }
    
    boolean is_capable(double volume) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    boolean is_capable(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    void deal(Contract c) {
        if (Tender.LOGGING)
            System.out.println("in deal method contract type " + c.type);
        switch (c.type){ // Определить тип контракта
            case Contract.MOX:
                if (Tender.LOGGING)
                    System.out.println("Deal Mox Contract ID:" + c.id);
                this.deal_mox(c); // МОКС контракты
                break;
            case Contract.EUP: // ОУП контракты
                if (Tender.LOGGING)
                    System.out.println("Deal OUP Contract");
                if (c.product == Contract.P_OUP){ // Контракт на покупку ОУП
                    if (Tender.LOGGING)
                        System.out.println("Deal EUP Contract ID:" + c.id);
                        this.deal_eup(c);
                        break;
                }
                else {
                    if ( c.product == Contract.P_PK ){ // Контракт на покупку ПК
                        if (Tender.LOGGING)
                            System.out.println("Deal PK Contract ID:" + c.id);
                        this.deal_pk(c);
                        break;
                    }
                    else {
                        throw new UnsupportedOperationException("Not supported product for this deal type");
                    }
                        
                }
            case Contract.SWU_PK:
                if (c.product == Contract.P_SWU){ // Контракт на покупку ЕРР
                    this.deal_swu_pk((ContractSWUPK) c);
                    break;
                }
                else {
                    if ( c.product == Contract.P_PK ){ // Контракт на покупку ПК
                        throw new UnsupportedOperationException("Not supported yet.");
                    }
                    else {
                        throw new UnsupportedOperationException("Not supported product for this deal type");
                    }
                        
                }
            case Contract.PK_Solo:{
                deal_pk(c);break;
            }
            case Contract.REMIX:{
                deal_remix(c);break;
            }
            default: throw new Error("Unknown type");    
        }
    }

    void deal_remix(Contract с) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    void deal_mox(Contract с) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    void deal_pk(Contract с) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    void deal_eup(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    void deal_swu_pk(ContractSWUPK c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    String getName(){
        return this.name;
    }
    
    Region getRegion(){
        return this.region;
    }
    
    Agent getAgent(){
        return this.agent;
    }
    
    ArrayList<Reactor> get_reactors(){
        return reactors;
    }
    
    public Statistic getStats(){
        return this.stats;
    }
    
    double calc_discount(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double calc_price(Contract c, double mean_pk_price) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void setName(String new_name){
        this.name = new_name;
    }

    public void setThreshold(double threshold) {
        this.threshold = threshold;
    }

    double calc_net_cost(Contract c, double mean_pk_price) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double calc_pk(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double calc_swu(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void initStats() {
        stats.setProdMaps();
    }

    double get_sum_neeeds() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    public boolean check_quota(Contract W){
        boolean failed_quota;
        if (W.get_reactor().ru_design){
            return false;
        }
        if (W.getClass().equals(Contract.class))
            {
              failed_quota =   getAgent().fail_quota(W);
            }else if (W.getClass().equals(ContractSWUPK.class)){
              failed_quota =   getAgent().fail_quota((ContractSWUPK) W);  
            }else throw new Error("Imposiible");
        return failed_quota;
    }

    void decrease_capacity(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double set_discount_price(ContractSWUPK c_swupk) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    double set_discount_price(Contract c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    double set_discount_price(Contract c, double mean_pj_price) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double calc_opt_tail_price(Contract c, double mean_pk_price) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    double set_opt_tail_discount_price(Contract c, double mean_pk_price) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    boolean isempty() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    boolean is_capable(Contract c, boolean piece) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void calc_needed_waste(double volume) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
