/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
/**
 *
 * @author Dmitry
 */
public class ArchiveChain {
    static private ArrayList<Contract> Contracts = new ArrayList();
    static private HashMap<Integer, HashMap<Actor,HashMap<Integer, Contract>>> ContractsMap = new HashMap();
    
    static void clear() {
      if(  Contracts.isEmpty())
        {return;}
      else
        {Contracts.clear();}
    }

    static void add(Contract new_contract) {
            if(new_contract.type == Contract.SWU_PK){
                split_and_archive(new_contract);return;
            }else{
                Contracts.add(new_contract);
            }
        archiveInMap(new_contract);   
            
    }
    
    static ArrayList<Contract> getContracts(){
        return Contracts;
    }

    static HashMap<Integer, HashMap<Actor,HashMap<Integer, Contract>>> getContractsMap(){
        return ContractsMap;
    }
    
    static ArrayList<Contract> getContracts(short P) {
        ArrayList<Contract> cosn = new ArrayList();
        Contracts.stream().filter(c -> c.product == P).forEachOrdered((c) -> {
            cosn.add(c);}
        );
        return cosn;
    }
    
    static HashMap getSpecificActorContract( int YearDelivery, Actor actor){
        try {
            return ContractsMap.get(YearDelivery).get(actor);
        } 
        catch(NullPointerException n){
            return null;
        }
        catch (Exception e) {
            throw e;
        }
    }
    
    static HashMap getSpecificActorContract( int YearDelivery){
        try {
            HashMap<Actor, HashMap<Integer, Contract>> aa = ContractsMap.get(YearDelivery);
            if (aa.isEmpty()){
                return null;
            }
            Set<Actor> f = aa.keySet();
            for (Iterator<Actor> iterator = f.iterator(); iterator.hasNext();) {
                Actor next = iterator.next();
                
            }
            return ContractsMap.get(YearDelivery);
        } 
        catch(NullPointerException n){
            return null;
        }
        catch (Exception e) {
            throw e;
        }
    }
    
    private static void split_and_archive(Contract new_contract) {
       Contract[] contracts = new_contract.split();
        for (Contract contract : contracts) {
            Contracts.add(contract);
            archiveInMap(contract);
        }
    }

    private static void archiveInMap(Contract new_contract) {
        if (ContractsMap.containsKey(Time.yTime)){
            HashMap YearDelivery = (HashMap) ContractsMap.get(new_contract.year);
            if (YearDelivery.containsKey(new_contract.get_buyer())){
                HashMap agent = (HashMap) YearDelivery.get(new_contract.get_buyer());
                if (agent.containsKey(new_contract.id)){
                    throw new Error("Contract tried to be writen in Archive twice");
                }else{
                  // HashMap<Integer, Contract> Contract = new HashMap();
                    //Contract.put(new_contract.id, new_contract);
                    agent.put(new_contract.id, new_contract);
                }
            }else{
                HashMap<Integer, Contract> Contract = new HashMap();
                Contract.put(new_contract.id, new_contract);
                YearDelivery.put((Actor) new_contract.get_buyer(), Contract);
            }
        }else{
            HashMap<Integer, Contract> coontract = new HashMap();
            coontract.put(new_contract.id, new_contract);

            HashMap<Actor,HashMap<Integer, Contract>> agent = new HashMap();
            agent.put((Actor) new_contract.get_buyer(), coontract);

            ContractsMap.put(new_contract.year, agent);
        }
    }
}
