/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.LinkedHashMap;

/**
 *
 * @author z
 */
public class Country {
    private int id;  
    private String name;
    private String region;

    double volume40;
    double volume80;
    double volume130;
    double volume260;
    double Svolume40;
    double Svolume80;
    double Svolume130;
    double Svolume260;
    
    double current_cost;
    
    double[] volume40_v;
    double[] volume80_v;
    double[] volume130_v;
    double[] volume260_v;
    double[] current_cost_v;
    double[] extracted;
    
    public Country(int id, String name, String region) {
        this.id = id;
        this.name = name;
        this.region = region;
        volume40_v = new double[Time.years.length];
        volume80_v = new double[Time.years.length];
        volume130_v = new double[Time.years.length];
        volume260_v = new double[Time.years.length];
        current_cost_v = new double[Time.years.length];
        extracted = new double[Time.years.length];
        
    }
    
    public Country(int id, String name){
        this.id = id;
        this.name = name;
    }
    
    public String getRegion(){
        return this.region;
    }
    
    public String getName(){
        return this.name;
    }
    
    public int getId(){
        return this.id;
    }
    
    public double getCurrentCost(){
        return this.current_cost;
    }    
    
    public double[] getVolumes(){
        double[] buf = {this.volume40, this.volume80, this.volume130, this.volume260};
        return buf;
    }
    
    public double[] getExtracted(){
        return this.extracted;
    }
    
    public double[] getCurrentCostV(){
        return this.current_cost_v;
    }
    
    public void setCurrentCost(double cost){
        this.current_cost = cost;
    }    
    
    public void setVolumes(double[] volumes){
        this.volume40 = volumes[0];
        this.volume80 = volumes[1];
        this.volume130 = volumes[2];
        this.volume260 = volumes[3];
        
        this.Svolume40 = this.volume40;
        this.Svolume80 = this.volume80;
        this.Svolume130 = this.volume130;
        this.Svolume260 = this.volume260;
    }
    
    public void new_cost(double volume){
        extracted[Time.iTime] = extracted[Time.iTime]+volume;
        if (volume40 >0){
            volume40 = volume40 - volume;
            if (volume40 <0){
                double diff = volume40*(-1);
                volume40 = 0;
                volume80 = volume80 - diff;
                current_cost = 80 + (1 - volume80/Svolume80)*(130-80);
            }else{
               current_cost = 40 + (1 - volume40/Svolume40)*(80-40); 
            }
        } else{
        if (volume80 >0){
            volume80 = volume80 - volume;
            if (volume80 <0){
                double diff = volume80*(-1);
                volume80 = 0;
                volume130 = volume130 - diff;
                current_cost = 130 + (1 - volume130/Svolume130)*(260-130);
                if (volume130 < 0){
                    diff = volume130*(-1);
                    volume130 = 0;
                    volume260 = volume260 - diff;
                    current_cost = 260 + (1 - volume260/Svolume260)*(520-260);
                }
            }else{
               current_cost = 80 + (1 - volume80/Svolume80)*(130-80); 
            }
        }else{
        if (volume130 >0){
            volume130 = volume130 - volume;
            if (volume130 <0){
                double diff = volume130*(-1);
                volume130 = 0;
                volume260 = volume260 - diff;
                current_cost = 260 + (1 - volume260/Svolume260)*(520-260);
            }else{
               current_cost = 130 + (1 - volume130/Svolume130)*(260-130);
            }
        }else{
        if (volume260 >0){
            volume260 = volume260 - volume;
        }      
        current_cost = 260 + (1 - volume260/Svolume260)*(520-260);       
        }
        }
        } 
    }
    
    public void write_turn_stat(){
        volume40_v[Time.iTime] = volume40;
        volume80_v[Time.iTime] = volume80;
        volume130_v[Time.iTime] = volume130;
        volume260_v[Time.iTime] = volume260;
        current_cost_v[Time.iTime] = current_cost;
    }  
    
    LinkedHashMap<String, Object> assembleSet(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        Eimport.put("Года", Time.years);
        Eimport.put("current cost", this.current_cost_v);
        Eimport.put("volume40", this.volume40_v);
        Eimport.put("volume80", volume80_v);
        Eimport.put("volume130", volume130_v);
        Eimport.put("volume260", volume260_v);
        Eimport.put("extracted", extracted);
        return Eimport;
    }

    public void new_cost(double volume, double cost, double old_cost) {
        extracted[Time.iTime] = extracted[Time.iTime]+volume;
        if (is_inside(cost, old_cost)){
            change_cost_inside(cost, volume);
        } else{
             change_cost_crossside(cost, old_cost, volume);
        }
        
        
    }
    
    private boolean is_inside(double cost, double old_cost){
        int cost_cat = write_cost_cat(cost);
        int old_cost_cat = write_cost_cat(old_cost);
        return cost_cat == old_cost_cat;
    }

    private int write_cost_cat(double cost) {
        if (cost < 40){
            return 1;
        }else{
            if (cost >= 40 & cost < 80){
                return 2;
            } else{ 
                if(cost >= 80 & cost < 130){
                    return 3;
                }else{
                    if(cost >= 130 & cost < 260){
                        return 4;
                    } else{
                        return 5;
                    }
                }
            }
        }
    }

    private void change_cost_inside(double cost, double volume) {
        int cost_cat = write_cost_cat(cost);
        switch(cost_cat){
            case 1: {
                volume40 = volume40 - volume;
                current_cost = 17 + (1 - volume40/Svolume40)*(40-17);
                break;
            }
            case 2: {
                volume80 = volume80 - volume;
                current_cost = 40 + (1 - volume80/Svolume80)*(80-40);
                break;
            }
            case 3: {
                volume130 = volume130 - volume;
                current_cost = 80 + (1 - volume130/Svolume130)*(130-80);
                break;
            }
            case 4: {
                volume260 = volume260 - volume;
                current_cost = 130 + (1 - volume260/Svolume260)*(260-130);
                break;
            }
        
        }
    }

    private void change_cost_crossside(double cost, double old_cost, double volume) {
        int cost_cat = write_cost_cat(cost);
         switch(cost_cat){
            case 2: {
                double A = (40 - old_cost)/(cost - old_cost);
                volume40 = volume40 - volume*A;
                if (volume40 < 0){
                    double diff = volume40*(-1);
                    volume80 = volume80 - diff - volume*(1-A);  
                    current_cost = 40 + (1 - volume80/Svolume80)*(80-40);
                } else{
                    volume80 = volume80 - volume*(1-A);
                    current_cost = 17 + (1 - volume40/Svolume40)*(40-17);
                }
                break;
            }
            case 3: {
                double A = (80 - old_cost)/(cost - old_cost);
                volume80 = volume80 - volume*A;
                if (volume80 < 0){
                    double diff = volume80*(-1);
                    volume130 = volume130 - diff - volume*(1-A);  
                    current_cost = 80 + (1 - volume130/Svolume130)*(130-80);
                } else{
                    volume130 = volume130 - volume*(1-A);
                    current_cost = 40 + (1 - volume80/Svolume80)*(80-40);
                }
                break;
            }
            case 4: {
                double A = (130 - old_cost)/(cost - old_cost);
                volume130 = volume130 - volume*A;
                if (volume130 < 0){
                    double diff = volume130*(-1);
                    volume260 = volume260 - diff - volume*(1-A);  
                    current_cost = 130 + (1 - volume260/Svolume260)*(260-130);
                } else{
                    volume260 = volume260 - volume*(1-A);
                    current_cost = 80 + (1 - volume130/Svolume130)*(130-80);
                }
            }
            break;
        }
    }
}
