/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author z
 */
public class DemoGuiActorProperties extends javax.swing.JFrame {

    private String EXCEL_FILE = "example_actors.xlsx";    // TODO: изменить?
    private String EXCEL_FILE_PATH = "./" + EXCEL_FILE; 
    
    private JTree jTree1;
   
    private Object participant;
    private String actor_name;      // последний выбранный в дереве актор
    private Class actor_class;      // класс переданного участника

    private ArrayList<Agent> my_agents;

    public DemoGuiActorProperties(JTree tree) {
        initComponents();
         
        this.jTree1 = tree;
        
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLayeredPane1 = new javax.swing.JLayeredPane();
        jButton6 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList<>();
        jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton7 = new javax.swing.JButton();

        javax.swing.GroupLayout jLayeredPane1Layout = new javax.swing.GroupLayout(jLayeredPane1);
        jLayeredPane1.setLayout(jLayeredPane1Layout);
        jLayeredPane1Layout.setHorizontalGroup(
            jLayeredPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jLayeredPane1Layout.setVerticalGroup(
            jLayeredPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setLocation(new java.awt.Point(1100, 0));
        setResizable(false);

        jButton6.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton6.setText("Изменить данные");
        jButton6.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton5.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton5.setText("Статистика участника");
        jButton5.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Список контрактов:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(800, 150));

        jScrollPane4.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane4.setPreferredSize(new java.awt.Dimension(346, 90));

        jList1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jList1.setModel(new DefaultListModel());
        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jList1.setCellRenderer(new DefaultListCellRenderer() {
            public java.awt.Component getListCellRendererComponent(JList list,
                Object value, int index, boolean isSelected,
                boolean cellHasFocus) {
                //                Contract cont = (Contract)value;
                //                setText(String.valueOf(cont.id));
                //                setIcon(new javax.swing.ImageIcon("/contract-icon.png"));
                //                setFont(list.getFont()); 
                //                setOpaque(true); 
                //                return this;
                java.awt.Component component = super.getListCellRendererComponent(list,
                    value, index, isSelected, cellHasFocus);
                ((javax.swing.JLabel) component).setIcon(new javax.swing.ImageIcon("src/contract-icon.png"));
                ((javax.swing.JLabel) component).setText(String.valueOf(((Contract)value).id));
                ((javax.swing.JLabel) component).setHorizontalTextPosition(CENTER);
                ((javax.swing.JLabel) component).setVerticalTextPosition(BOTTOM);
                ((javax.swing.JLabel) component).setFont(list.getFont());
                //((javax.swing.JLabel) component).set
                return component;
            }
        });
        jList1.setLayoutOrientation(javax.swing.JList.HORIZONTAL_WRAP);
        jList1.setPreferredSize(new java.awt.Dimension(790, 119));
        jList1.setVisibleRowCount(1);
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane4.setViewportView(jList1);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Описание:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(801, 569));

        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setAutoscrolls(true);
        jScrollPane2.setPreferredSize(jTextArea2.getPreferredSize());

        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTextArea2.setRows(5);
        jTextArea2.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jTextArea2.setEnabled(false);
        jTextArea2.setPreferredSize(new java.awt.Dimension(376, 538));
        jScrollPane2.setViewportView(jTextArea2);

        jTable1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Год", "Стоимость", "Ресурсы"
            }
        ));
        jTable1.setPreferredSize(new java.awt.Dimension(410, 710));
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane6.setViewportView(jTable1);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 347, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE)
                    .addComponent(jScrollPane6))
                .addContainerGap())
        );

        jButton7.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton7.setText("Сохранить статистику");
        jButton7.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 255, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 801, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButton6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 752, Short.MAX_VALUE)
                .addGap(13, 13, 13)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    // <editor-fold defaultstate="collapsed" desc="jTable functions">
    private void createTableEnrichment(Enrichment actor){
         
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        Object[] row = new Object[model.getColumnCount()];
        
        for (int i=0; i < Time.years.length; i++){       //actor.all_capacity.length
            row[0] = Time.years[i];
            row[1] = actor.all_cost[i];
            row[2] = actor.all_capacity[i];
            
            model.addRow(row);
        }
    }
    
    private void createTableMining(Mining actor){
        jTable1.setVisible(false);
//        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
//        
//        if (! model.getDataVector().isEmpty()){
//            model.getDataVector().removeAllElements();
//        }
//        
//        Object[] row = new Object[model.getColumnCount()];
//        
//        for (int i=0; i < Time.years.length; i++){      //actor.all_capacity.length
//            row[0] = Time.years[i];
//            row[1] = actor.all_cost[i];
//            row[2] = actor.all_capacity[i];
//            
//            model.addRow(row);
//        }
    }
    
    private void clearTable(javax.swing.JTable table){
        table.setVisible(true);
        DefaultTableModel model = (DefaultTableModel) table.getModel();
        
        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        table.updateUI();

    }
    
    // </editor-fold> 
    
    //<editor-fold defaultstate="collapsed" desc="jButtonActionPerformed">
    
    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // change parameters
        if (this.actor_class.equals(Enrichment.class)){
            //jTextArea1.append(String.valueOf(jTree1.getLastSelectedPathComponent())+"\n");
            DemoGuiChangeParamsEnrich module = new DemoGuiChangeParamsEnrich((Enrichment) this.participant);
            module.setVisible(true);
            module.addWindowListener(new WindowListener(){
                @Override
                public void windowClosed(WindowEvent e) {              
                    outputEnrichment((Enrichment) module.getActor());
                    clearTable(jTable1);
                    createTableEnrichment((Enrichment) module.getActor());
                }
                
                @Override
                public void windowActivated(WindowEvent e) {}

                @Override
                public void windowOpened(WindowEvent e) {}

                @Override
                public void windowClosing(WindowEvent e) {}

                @Override
                public void windowIconified(WindowEvent e) {}

                @Override
                public void windowDeiconified(WindowEvent e) {}

                @Override
                public void windowDeactivated(WindowEvent e) {}
            });
        }
        else if(this.actor_class.equals(Mining.class)){
            //jTextArea1.append(String.valueOf(jTree1.getLastSelectedPathComponent())+"\n");
            DemoGuiChangeParamsMining module = new DemoGuiChangeParamsMining((Mining) this.participant);
            module.setVisible(true);
            module.addWindowListener(new WindowListener(){
                @Override
                public void windowClosed(WindowEvent e) {              
                    outputMinings((Mining) module.getActor());
                    clearTable(jTable1);
                    createTableMining((Mining) module.getActor()); 
                }
                
                @Override
                public void windowActivated(WindowEvent e) {}

                @Override
                public void windowOpened(WindowEvent e) {}

                @Override
                public void windowClosing(WindowEvent e) {}

                @Override
                public void windowIconified(WindowEvent e) {}

                @Override
                public void windowDeiconified(WindowEvent e) {}

                @Override
                public void windowDeactivated(WindowEvent e) {}
            });
            
            
        }
        /*else if (this.actor_class.equals(Agent.class)){           
            ArrayList<String> agents_names = new ArrayList<>();
                          
            for (int i=0; i < this.my_agents.size(); i++){
                agents_names.add(i, this.my_agents.get(i).getName());
            }
            
            DemoGuiAgentProperties module = new DemoGuiAgentProperties((Agent) this.participant, agents_names, this.my_agents);
            module.setVisible(true);   
        }*/
        else{
            JOptionPane.showMessageDialog(new JPanel(),"Not supported yet", "Исключение!",
                    JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // Show contracts list
        
        if (this.actor_class.equals(Operator.class)){
            (new DemoGuiOperatorStatistics((Operator)this.participant)).setVisible(true);
            DefaultListModel listModel = (DefaultListModel) jList1.getModel();
           listModel.removeAllElements();

           for (int i=0; i < ContractChain.getContracts().size(); i++){ 
               //System.out.println(String.valueOf(ContractChain.getContracts().get(i).get_current_owner().getName().equals(this.actor_name)));
               if (ContractChain.getContracts().get(i).get_current_owner().getName().equals(this.actor_name)){
                   listModel.addElement(ContractChain.getContracts().get(i));              
               }            
           }       
        
        }

        if (this.actor_class.equals(Mining.class)){
            (new DemoGuiMiningStatistics((Mining)this.participant)).setVisible(true);
            DefaultListModel listModel = (DefaultListModel) jList1.getModel();
            listModel.removeAllElements();
        }

        //jList1.setModel(listModel);
    }//GEN-LAST:event_jButton5ActionPerformed
//</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="jList functions">
    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        Contract selectedValue = (Contract)((JList)evt.getSource()).getSelectedValue();
        printContractInfo(selectedValue); 
        //jList1.updateUI();
        //DefaultListModel listModel = (DefaultListModel) jList1.getModel();
        jList1.getSelectionModel().removeSelectionInterval(1,1); // или пробуй jList1.clearSelection()
    }//GEN-LAST:event_jList1ValueChanged

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // export to excel
        try {
            if (this.actor_class.equals(Operator.class)){
                Function<Operator, LinkedHashMap> func = (actor)-> actor.getStats().assembleOperatorSet();
                ExcelLoader<Operator> el = new ExcelLoader<>(EXCEL_FILE_PATH);
                el.writeIntoExcel((Operator) this.participant, func, "Оператор "+actor_name);
            }
            else if (this.actor_class.equals(Enrichment.class)){
                Function<Enrichment, LinkedHashMap> func = (actor)-> actor.getStats().assembleEnrichmentSet();
                ExcelLoader<Enrichment> el = new ExcelLoader<>(EXCEL_FILE_PATH);
                el.writeIntoExcel((Enrichment)this.participant, func, "Обогатитель "+actor_name);
            }
            else{
                Function<Actor, LinkedHashMap> func = (actor)-> actor.getStats().assembleActorSet();
                ExcelLoader<Actor> el = new ExcelLoader<>(EXCEL_FILE_PATH);
                el.writeIntoExcel((Actor)this.participant, func, actor_name);
            }
            JOptionPane.showMessageDialog(new JPanel(),"Сохранено", "Готово!",
                    JOptionPane.INFORMATION_MESSAGE);
        }
        catch (IOException ex) {
            Logger.getLogger(DemoGuiArchive.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButton7ActionPerformed

    private void printContractInfo(Contract selectedContract){
        try{
            jTextArea2.setText("");
            String msg = "Контракт "+selectedContract.id+"\n\n";
            jTextArea2.append(msg);
            msg = "Покупатель: "+ selectedContract.get_buyer().getName() + "\n";
            jTextArea2.append(msg);
            msg = "Продавец: "+ selectedContract.get_seller().getName() + "\n";
            jTextArea2.append(msg);
            msg = "Продукт: "+ selectedContract.get_product() + "\n";
            jTextArea2.append(msg);
            msg = "Объем: "+ String.format("%.2f", selectedContract.volume) + "\n";
            jTextArea2.append(msg);
            msg = "Стоимость = "+ String.format("%.2f", selectedContract.price) + "\n";
            jTextArea2.append(msg);
            msg = "Год сделки: "+ String.valueOf(selectedContract.year) + "\n";
            msg += "Год доставки: "+ String.valueOf(selectedContract.year) + "\n";

            jTextArea2.append(msg); 
        }
        catch (java.lang.NullPointerException e){
            jTextArea2.setText("NULLLLLL");
       }
    }

    private void clearList(){
        DefaultListModel listModel = (DefaultListModel) this.jList1.getModel();
        listModel.removeAllElements();
    }
//</editor-fold>
       
    // <editor-fold defaultstate="collapsed" desc="Properties output">
    
    private void outputAgent(Agent ag){
        String msg = "Агент "+ ag.getName() + "\n\n";
        
        msg += "Операторы: \n";
        for (int i=0; i < ag.get_operators().size(); i++){
            msg += ag.get_operators().get(i).getName() + "\n";
        }
        
        msg += "\nПоставщики природного урана: \n";
        for (int i=0; i < ag.get_minings().size(); i++){
            msg += ag.get_minings().get(i).getName() + "\n";
        }
        
        msg += "\nОбогатительные предприятия: \n";
        for (int i=0; i < ag.get_enrichments().size(); i++){
            msg += ag.get_enrichments().get(i).getName() + "\n";
        }
        
        msg += "\nПоставщики МОКСа: \n";
        for (int i=0; i < ag.get_mox_suppliers().size(); i++){
            msg += ag.get_mox_suppliers().get(i).getName() + "\n";
        }

        jTextArea2.setText(msg);
    }    
    
//    private void outputFabricator(Fabricator actor){
//        // TO DO
//        String msg = "Fabricator properties:\n\n";
//
////            msg += "Название:\n"+ actor.getName() + "\n";
////            msg += "Cost = " + actor.cost;
////            msg += "\nМощность = " + actor.capacity;
//
//        msg += "Not supported yet";
//        jTextArea2.setText(msg);
//    }
    
    
    private void outputReactor(Reactor reactor){
        String msg = "Реактор "+ reactor.name + ":\n\n";
        msg += "\nСтрана: "+reactor.getCountry().getName();
        msg += "\nРегион: "+reactor.getCountry().getRegion();
        msg += "\n\nКласс: "+reactor.Rclass;
        msg += "\nЭлектрическая мощность = " + reactor.electrical_capacity;
        msg += "\nТермическая мощность = " + reactor.termal_capacity;
        //msg += "\nСтатус: " + reactor.status;
        msg += "\nКИУМ = " + reactor.eaf;
        msg += "\nПотребности: " + "not supported yet";//actor.reactors.get(j).;
        msg += "\nКоэффициент выгорания: " + reactor.burnup;
        jTextArea2.setText(msg);
    }
    
    private void outputMinings(Mining actor){
        String msg = "Поставщик природного урана:\n\n";
        msg += "Название: "+ actor.getName();
        msg += "\nАгент: "+ actor.getAgent().getName();
        msg += "\nРегион: "+ actor.getRegion().name;
        msg += "\n\nСтоимость = " + actor.getCost();
        msg += "\nСуммарный запас = " + actor.getCapacity() + " т";
        msg += "\nКоэф-т производительности = " + actor.getProductionRate();
        msg += "\n\nМесторождения: \n"; 
        jTextArea2.setText(msg);
        actor.getDeposits().forEach(dep -> jTextArea2.append(dep.getName()+"\n"));
        //jTextArea2.setText(msg);
        
        createTableMining(actor);
    }

    
    private void outputEnrichment(Enrichment actor){
        String msg = "Обогатительное предприятие:\n\n";
        msg += "Название: "+ actor.getName();
        msg += "\nАгент: "+ actor.getAgent().getName();
        msg += "\nРегион: "+ actor.getRegion().name;
        msg += "\n\nСтоимость = " + actor.cost;
        msg += "\nОбщие потребности = " + "not supported yet";
        msg += "\n\nМощность = " + actor.capacity;
        msg += "\nСуммарная мощность = " + "not supported yet";
        jTextArea2.setText(msg);

        createTableEnrichment(actor);
    }
    
    private void outputMOX(MoxSupplier actor){
        String msg = "MOX Supplier properties:\n\n";
        msg += "Название: "+ actor.getName();
        msg += "\n\nАгент: "+ actor.getAgent().getName();
        msg += "\n\nСтоимость = " + actor.cost;
        msg += "\nОбщие потребности = " + "not supported yet";
        msg += "\n\nМощность = " + actor.capacity;
        msg += "\nСуммарная мощность = " + "not supported yet";
        jTextArea2.setText(msg);

    }

    private void outputRemix(RemixSupplier actor){
        String msg = "Remix Supplier properties:\n\n";
        msg += "Название: "+ actor.getName();
        msg += "\n\nАгент: "+ actor.getAgent().getName();
        msg += "\n\nСтоимость = " + actor.cost;
        msg += "\nОбщие потребности = " + "not supported yet";
        msg += "\n\nМощность = " + actor.capacity;
        msg += "\nСуммарная мощность = " + "not supported yet";
        jTextArea2.setText(msg);

    }
    
 // </editor-fold> 
    
    // <editor-fold defaultstate="collapsed" desc="Public functions for managing">
    /*
    Here are a couple functions for adding text to JTextArea2
    and functions for Frame updating.
    Algorithm of updating:
    1) clear List, Table;
    2) assignment args to private  fields;
    3) fill jTextArea & Table (call output* function).
    */
 
    public void setText(String msg){
        this.jTextArea2.setText(msg);
    }
    
    public void appendText(String msg){
        this.jTextArea2.append(msg);
    }
    
    // если класс неверный
    public void update_UI(String msg){
        clearList();
        clearTable(this.jTable1);
        
        this.jTextArea2.setText(msg);
    }
    
    // для реакторв
    public void update_UI(Reactor reac, String reac_name, Class reac_class){
        clearList();
        clearTable(this.jTable1);

        this.participant = reac;
        this.actor_name = reac_name;
        this.actor_class = reac_class;
        
        outputReactor(reac);
    }

    // для любого Producer'а
    public void update_UI(Producer prod, String prod_name, Class prod_class){
        clearList();      
        clearTable(jTable1);
        
        this.participant = prod;
        this.actor_name = prod_name;
        this.actor_class = prod_class;
        
        if (prod_class.equals(Enrichment.class)){
            outputEnrichment((Enrichment) prod);
        }
        else if (prod_class.equals(Mining.class)){
            outputMinings((Mining) prod);
        }
        else if (prod_class.equals(MoxSupplier.class)){
            outputMOX((MoxSupplier) prod);
        }
        else if (prod_class.equals(RemixSupplier.class)){
            outputRemix((RemixSupplier) prod);
        }
        //else if (prod_class.equals(Fabricator.class)){outputFabricator((Fabricator) prod)}
        
    }
   
 // </editor-fold>    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JList<String> jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextArea jTextArea2;
    // End of variables declaration//GEN-END:variables
}
