/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import Graphic.LineChart;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

/**
 *
 * @author z
 */
public class DemoGuiEup extends javax.swing.JFrame {
    boolean ERROR_AVAILABLE = Boolean.FALSE; // связать с пунктом меню
    private String buffer_local = "";     // для сохранения текста при переоде от локального к миру и назад
    private boolean is_visible = false;     // для сохранения инфы, было ли открыто окно свойств участника
    private String buffer_world = ""; 
    private DemoModule dm1;
    private DemoGuiActorProperties dg_actor_prop;
    private DemoGuiCountryProperties dg_country_prop;
    
    static final String AGENT_LABEL = "Агенты";
    static final String COUNTRY_LABEL = "Страны";
    static final String PARTICIPANT_LABEL = "Участники";
    static final String FABRICATOR_LABEL = "Фабрикаторы";
    static final String OPERATOR_LABEL = "Операторы";
    static final String MINING_LABEL = "Поставщики природного урана";
    static final String ENRICH_LABEL = "Обогатительные предприятия";
    static final String MOX_LABEL = "Поставщики МОКСа";
    static final String REACTOR_TREE_LABEL = "Страны";
    String LAST_CHOOSEN_ACTOR = "";      // последний выбранный в дереве актор
    Class LAST_CHOOSEN_ACTOR_CLASS = Object.class;      // и его класс
    
    public DemoGuiEup() {
        dm1 = new DemoModule();
        this.dm1.setup();
        initComponents();
        this.jButton5.setVisible(false);
        createTree();
        dg_actor_prop = new DemoGuiActorProperties(this.jTree1);
        dg_country_prop = new DemoGuiCountryProperties();
            
    }

    public DemoGuiEup(String demo4) {
        dm1 = new DemoModule(demo4);
        this.dm1.setup();
        initComponents();
        this.jButton5.setVisible(false);
        createTree();   
        dg_actor_prop = new DemoGuiActorProperties(this.jTree1);
    }
    
    public DemoGuiEup(String demo4, String DB_path, String AF) {
        dm1 = new DemoModule(demo4);
        dm1.scenario.setBd_path(DB_path);
        dm1.scenario.setAGENT_FOULDER(AF);
        this.dm1.setup();
        initComponents();
        this.jButton5.setVisible(false);
        createTree();   
        dg_actor_prop = new DemoGuiActorProperties(this.jTree1);
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        jPanel1 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel2 = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        jButton7 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jButton9 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jPanel1.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(440, 1020));

        jScrollPane5.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane5.setAutoscrolls(true);
        jScrollPane5.setPreferredSize(new java.awt.Dimension(322, (int) jTree1.getSize().getHeight()));

        jTree1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("root");
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.setCellRenderer(new DefaultTreeCellRenderer(){
            public java.awt.Component getTreeCellRendererComponent(javax.swing.JTree pTree,
                Object pValue, boolean pIsSelected, boolean pIsExpanded,
                boolean pIsLeaf, int pRow, boolean pHasFocus) {
                java.awt.Component component = super.getTreeCellRendererComponent(pTree,
                    pValue, pIsSelected, pIsExpanded, pIsLeaf, pRow, pHasFocus);
                try {
                    //                        ((javax.swing.JLabel) component).setText( ((DefaultMutableTreeNode)pValue).get );
                    //                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    DefaultMutableTreeNode node = (DefaultMutableTreeNode)pValue;

                    if (node.getUserObject() instanceof Agent){
                        ((javax.swing.JLabel) component).setText( ((Agent)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Actor){
                        ((javax.swing.JLabel) component).setText( ((Actor)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Region){
                        ((javax.swing.JLabel) component).setText(((Region)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Country){
                        ((javax.swing.JLabel) component).setText(((Country)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Reactor){
                        ((javax.swing.JLabel) component).setText("Реактор " + ((Reactor)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof Deposit){
                        ((javax.swing.JLabel) component).setText(((Deposit)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof RemixSupplier){
                        ((javax.swing.JLabel) component).setText(((Deposit)(node.getUserObject())).getName() );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    if (node.getUserObject() instanceof String){
                        ((javax.swing.JLabel) component).setText( (String)(node.getUserObject()) );
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                }
                catch(java.lang.ClassCastException e){
                    ((javax.swing.JLabel) component).setText(String.valueOf(pValue));
                    ((javax.swing.JLabel) component).setFont(pTree.getFont());
                }

                return component; 
            }   
        });
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane5.setViewportView(jTree1);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 412, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 985, Short.MAX_VALUE)
                .addContainerGap())
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Статистика", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 24))); // NOI18N
        jPanel2.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N

        jRadioButton1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton1.setText("Показать Мир");
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jComboBox1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Совокупный спрос", "Совокупный предл-е", "Средняя стоимость" }));
        jComboBox1.setSelectedIndex(-1);
        jComboBox1.setSelectedItem("Выберите пункт");

        jLabel1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jLabel1.setText("Выберите характеристку:");
        jLabel1.setOpaque(true);

        jButton7.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton7.setText("Построить график");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jTextArea1.setEditable(false);
        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setPreferredSize(new java.awt.Dimension(634, 200));
        jScrollPane1.setViewportView(jTextArea1);
        jTextArea1.setLineWrap(true);
        jTextArea1.setWrapStyleWord(true);

        jButton9.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton9.setText("Разбить");
        jButton9.setEnabled(false);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        jButton5.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton5.setText("Установить отвал");

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, jRadioButton1, org.jdesktop.beansbinding.ELProperty.create("${selected}"), jButton5, org.jdesktop.beansbinding.BeanProperty.create("enabled"));
        bindingGroup.addBinding(binding);

        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jTable2.setFont(new java.awt.Font("Times New Roman", 0, 14)); // NOI18N
        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null}
            },
            new String [] {
                "Характеристика", "Год", "ПК", "ЕРР", "ОУП", "МОКС"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable2.setRowSelectionAllowed(false);
        jTable2.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jTable2.getTableHeader().setReorderingAllowed(false);
        jScrollPane7.setViewportView(jTable2);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 520, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jRadioButton1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButton5))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                                .addComponent(jComboBox1, 0, 338, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton7))
                            .addComponent(jScrollPane1))
                        .addComponent(jButton9, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel1))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane7)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jRadioButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 300, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton9, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 400, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane7)))
                .addContainerGap())
        );

        jButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton2.setText("Запуск");
        jButton2.setPreferredSize(new java.awt.Dimension(195, 70));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton3.setText("Показать Архив");
        jButton3.setEnabled(false);
        jButton3.setPreferredSize(new java.awt.Dimension(195, 70));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton8.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton8.setText("Задать перспективные реакторы");
        jButton8.setEnabled(false);
        jButton8.setPreferredSize(new java.awt.Dimension(195, 70));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 323, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27)
                        .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 1015, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel1.getAccessibleContext().setAccessibleName("");

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void start_announce(){
        jTextArea1.setVisible(true);
        if (this.jTextArea1.getText().equalsIgnoreCase("")){
            jTextArea1.setText("\nНажата кнопка Запуск\n");
        }
        else{
            jTextArea1.append("\nНажата кнопка Запуск\n");
        }
    }
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Continuous
        
        start_announce();
        try{
            this.dm1.run(jTextArea1);
            
            if (jRadioButton1.isSelected()){
                clearTable(this.jTable2);
                updateTable();
            }
            
            JOptionPane.showMessageDialog(new JPanel(),"Расчеты выполнены", "Оповещение!",
                    JOptionPane.INFORMATION_MESSAGE);
            jButton3.setEnabled(true);
            jTabbedPane1.updateUI();
        }
        catch(Exception e){
            if (ERROR_AVAILABLE){

                JOptionPane.showMessageDialog(new JPanel(),e.toString(), "Исключение!",
                    JOptionPane.ERROR_MESSAGE);
            }
            else{
                e.printStackTrace(System.err);
            }
         }  
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // DemoGuiArchive
        DemoGuiArchive module = new DemoGuiArchive();
        module.setVisible(true); 
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        // TODO: перспективные реакторы
    }//GEN-LAST:event_jButton8ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // Draw graph
        if (jRadioButton1.isSelected()){
            String item = String.valueOf(jComboBox1.getSelectedItem());
        
            if (item.equals("Совокупный спрос")){
                updateIntFrameDemands();
            }
            else if (item.equals("Совокупный предл-е")){
                updateIntFrameSupply();
            }
            else if (item.equals("Средняя стоимость")){
                updateIntFrameMeanPrices();
            }
            this.jButton9.setEnabled(true);
        }
    }//GEN-LAST:event_jButton7ActionPerformed

    //</editor-fold>
   
    // <editor-fold defaultstate="collapsed" desc="jTree functions">
    private void createTree(){
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("");
        DefaultTreeModel model = new DefaultTreeModel(root);
        jTree1.setModel(model);

        TreeAgent agents = new TreeAgent(this.dm1);     
        TreeActor participants = new TreeActor(this.dm1);
        
        model.insertNodeInto(agents.getRoot(), root, 0);
        model.insertNodeInto(participants.getRoot(), root, 1);
        model.insertNodeInto(createReactorsTree(), root, 2);

        // чтобы при запуске в дереве не надо было раскрывать список классов акторов
        
        jTree1.expandPath(new TreePath(root.getPath()));
        jTree1.expandRow(3);        // нет, тут нельзя переделать на 1,2,3. Дерево нормально раскрывается только в такой посл-сти
        jTree1.expandRow(2);
        //jTree1.expandRow(1);
        jTree1.setRootVisible(false);
    }
    
    private DefaultMutableTreeNode createReactorsTree(){
        DefaultMutableTreeNode root = new DefaultMutableTreeNode(REACTOR_TREE_LABEL);
        DefaultTreeModel model = new DefaultTreeModel(root);
        
        // сначала заполним все поддеревья со странами
        ArrayList<DefaultMutableTreeNode> countries = new ArrayList<>();
        this.dm1.getCountries().forEach((id,coun) -> countries.add(new DefaultMutableTreeNode(coun)));     // записываем страны на места согласно их id
        if (countries.size() != 0){
            for (int i=0; i < this.dm1.my_reactors.size(); i++){
                // относим рекаторы к эл-там массива соглавно id страны реактора
                Reactor reac = this.dm1.my_reactors.get(i);
                countries.get(reac.getCountry().getId()-1).add(new DefaultMutableTreeNode(reac));
            }
        }

        // теперь раскидаем по регионам страны
        ArrayList<DefaultMutableTreeNode> regions = new ArrayList<>();
        this.dm1.my_regions.forEach(reg -> regions.add(new DefaultMutableTreeNode(reg)));
        countries.forEach(coun -> {
            String reg_name1 = ((Country) coun.getUserObject()).getRegion();
            
            regions.forEach(reg -> {
                String reg_name2 = ((Region) reg.getUserObject()).getName();
                if (reg_name1.equals(reg_name2)){              //((Region) reg.getUserObject()).getCountries().contains((Country) coun.getUserObject())
                    //System.out.println(reg_name2);
                    reg.add(coun);
                } 
            });
            
        });
        
        // наконец заподняем корень
        for (int i=0; i < regions.size(); i++){
            root.add(regions.get(i));
        }

        return root;
    }
    
    private void updateTree(){
        jTree1.updateUI();
    }
    
    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        try{
            // ошибка может возникнуть в этой строке, если там обычный String
            DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)evt.getPath().getLastPathComponent();
   
            //<editor-fold defaultstate="collapsed" desc="AGENT">
            if (selectedNode.getUserObject() instanceof Agent){
                LAST_CHOOSEN_ACTOR = ((Agent)selectedNode.getUserObject()).getName();
                LAST_CHOOSEN_ACTOR_CLASS  = Agent.class;

                if (dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(false);
                }

                ArrayList<String> my_agents_names = new ArrayList();
                for (int i=0; i < dm1.my_agents.size(); i++){
                    my_agents_names.add(i, dm1.my_agents.get(i).getName());
                }
                Agent node = (Agent)selectedNode.getUserObject();
                (new DemoGuiAgentProperties(node, my_agents_names, this.dm1.my_agents,
                node.getReadedRelations(), node.getReadedLogistics(),
                        node.getReadedQuotas())).setVisible(true);
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="OPERATOR">
            if (selectedNode.getUserObject() instanceof Operator){
                Operator actor_op = (Operator)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = actor_op.getName();
                LAST_CHOOSEN_ACTOR_CLASS = Operator.class;

                DemoGuiOperatorProperties oper_prop = new DemoGuiOperatorProperties(this.jTree1);
                oper_prop.update_UI(actor_op, LAST_CHOOSEN_ACTOR);
                oper_prop.setVisible(true);
                oper_prop.addWindowListener(new WindowListener(){
                    @Override
                    public void windowClosed(WindowEvent e) {}

                    @Override
                    public void windowActivated(WindowEvent e) {}

                    @Override
                    public void windowOpened(WindowEvent e) {}

                    @Override
                    public void windowClosing(WindowEvent e) {}

                    @Override
                    public void windowIconified(WindowEvent e) {}

                    @Override
                    public void windowDeiconified(WindowEvent e) {}

                    @Override
                    public void windowDeactivated(WindowEvent e) {
                        updateTree();
                    }
                });

                this.dg_actor_prop.setVisible(false);
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="MINING">
            if (selectedNode.getUserObject() instanceof Mining){
                Mining actor_min = (Mining)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = actor_min.getName();
                LAST_CHOOSEN_ACTOR_CLASS = Mining.class;
                this.dg_actor_prop.update_UI(actor_min, LAST_CHOOSEN_ACTOR, LAST_CHOOSEN_ACTOR_CLASS);
                if (! dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(true);
                }
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="ENRICHMENT">
            if (selectedNode.getUserObject() instanceof Enrichment){
                Enrichment actor_enr = (Enrichment)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = actor_enr.getName();
                LAST_CHOOSEN_ACTOR_CLASS = Enrichment.class;
                this.dg_actor_prop.update_UI(actor_enr, LAST_CHOOSEN_ACTOR, LAST_CHOOSEN_ACTOR_CLASS);
                if (! dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(true);
                }
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="MOX">
            if (selectedNode.getUserObject() instanceof MoxSupplier){
                MoxSupplier actor_mox = (MoxSupplier)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = actor_mox.getName();
                LAST_CHOOSEN_ACTOR_CLASS = MoxSupplier.class;
                this.dg_actor_prop.update_UI(actor_mox, LAST_CHOOSEN_ACTOR, LAST_CHOOSEN_ACTOR_CLASS);
                if (! dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(true);
                }
            }
            
            //<editor-fold defaultstate="collapsed" desc="MOX">
            if (selectedNode.getUserObject() instanceof RemixSupplier){
                RemixSupplier actor_mox = (RemixSupplier)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = actor_mox.getName();
                LAST_CHOOSEN_ACTOR_CLASS = RemixSupplier.class;
                this.dg_actor_prop.update_UI(actor_mox, LAST_CHOOSEN_ACTOR, LAST_CHOOSEN_ACTOR_CLASS);
                if (! dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(true);
                }
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="FABRICATOR">
    //        if (selectedNode.getUserObject() instanceof Fabricator){
    //            Fabricator actor_fab = (Fabricator)selectedNode.getUserObject();
    //            LAST_CHOOSEN_ACTOR = actor_fab.getName();
    //            LAST_CHOOSEN_ACTOR_CLASS = Fabricator.class;
    //            clearTable(jTable1);
    //            outputFabricator(actor);
    //        }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="REGION">
            if (selectedNode.getUserObject() instanceof Region){
                LAST_CHOOSEN_ACTOR = ((Region)selectedNode.getUserObject()).getName();
                LAST_CHOOSEN_ACTOR_CLASS  = Country.class;

                if (dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(false);
                }

                (new DemoGuiRegionProperties((Region)selectedNode.getUserObject())).setVisible(true);
            }
    //</editor-fold>
    
            //<editor-fold defaultstate="collapsed" desc="COUNTRY">
            if (selectedNode.getUserObject() instanceof Country){
                LAST_CHOOSEN_ACTOR = ((Country)selectedNode.getUserObject()).getName();
                LAST_CHOOSEN_ACTOR_CLASS  = Country.class;

                if (dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(false);
                }

                (new DemoGuiCountryProperties((Country)selectedNode.getUserObject())).setVisible(true);
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="REACTOR">
            if (selectedNode.getUserObject() instanceof Reactor){
                Reactor reac = (Reactor)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = reac.getName();
                LAST_CHOOSEN_ACTOR_CLASS = Reactor.class;
                //this.dg_actor_prop.update_UI(reac, LAST_CHOOSEN_ACTOR, LAST_CHOOSEN_ACTOR_CLASS);

                if (dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(false);
                }
                (new DemoGuiReactorProperties((Reactor)selectedNode.getUserObject())).setVisible(true);
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="DEPOSIT">
            if (selectedNode.getUserObject() instanceof Deposit){
                Deposit dep = (Deposit)selectedNode.getUserObject();
                LAST_CHOOSEN_ACTOR = dep.getName();
                LAST_CHOOSEN_ACTOR_CLASS = Deposit.class;

                if (dg_actor_prop.isVisible()){
                    dg_actor_prop.setVisible(false);
                }
                (new DemoGuiDepositProperties((Deposit)selectedNode.getUserObject())).setVisible(true);
            }
    //</editor-fold>

            //<editor-fold defaultstate="collapsed" desc="ANOTHER OBJECT">
    //        if (selectedNode.getUserObject() instanceof Deposit){
    //            Deposit dep = (Deposit)selectedNode.getUserObject();
    //            LAST_CHOOSEN_ACTOR = dep.getName();
    //            LAST_CHOOSEN_ACTOR_CLASS = Deposit.class;
    //
    //            if (dg_actor_prop.isVisible()){
    //                dg_actor_prop.setVisible(false);
    //            }
    //            (new DemoGuiDepositProperties((Deposit)selectedNode.getUserObject())).setVisible(true);
    //        }
    //</editor-fold>

        }
        
        catch (java.lang.ClassCastException e){
            // если этовсе же String
            jTextArea1.append("\n"+"Node"+" is selected\n");
        }

        finally{
            // обязательно сбрасываем путь!!!
            Object[] pp = {""};
            jTree1.setSelectionPath(new TreePath(pp));
        }
    }//GEN-LAST:event_jTree1ValueChanged

    
// </editor-fold> 
    
    // <editor-fold defaultstate="collapsed" desc="jTable functions">  
    private void clearTable(javax.swing.JTable table){
        DefaultTableModel model = (DefaultTableModel) table.getModel();
        
        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        table.updateUI();

    }
    
    private void updateTable(){
        String[] characteristics = {"Совокупный спрос", "Совокупный предл-е", "Средняя стоимость"};
        for (int i=0; i < characteristics.length; i++){
            createTableWorld(characteristics[i]);
        }
        
        //jTable2.scrollRectToVisible(jTable2.getCellRect(jTable2.getRowCount()-1, 0, true));
        jTable2.setSize(452, 874);
        jScrollPane7.setSize(jTable2.getSize());
    }
    
    private void createTableWorld(String characteristic){
        
        short[] codes = {Contract.P_PK,Contract.P_SWU,Contract.P_OUP, Contract.P_MOX};
        
        DefaultTableModel model = (DefaultTableModel) jTable2.getModel();
        model.addRow(new Object[]{characteristic, "", "", "", "", ""});
        
        Object[] row = new Object[model.getColumnCount()];

        if (characteristic.equals("Совокупный спрос")){
            for (int i=0; i < Time.years.length; i++){          //World.total_pk_demand.length
                row[0] = "";
                row[1] = Time.years[i];
                row[2] = String.format("%.2f", World.total_pk_demand[i]);
                row[3] = String.format("%.2f", World.total_swu_demand[i]);
                row[4] = String.format("%.2f", World.total_eup_demand[i]);
                row[5] = String.format("%.2f", World.total_mox_demand[i]);
                
                model.addRow(row);
            }
        }       
        
        if (characteristic.equals("Совокупный предл-е")){
            for (int i=0; i < Time.years.length; i++){      //World.total_pk_supply.length
                row[0] = "";
                row[1] = Time.years[i];
                row[2] = String.format("%.2f", World.total_pk_supply[i]);
                row[3] = String.format("%.2f", World.total_swu_supply[i]);
                row[4] = "-";
                row[5] = String.format("%.2f", World.total_mox_supply[i]);
                
                model.addRow(row);
            }
        }    
        
        if (characteristic.equals("Средняя стоимость")){
            for (int i=0; i < Time.years.length; i++){      //World.total_pk_supply.length
                row[1] = Time.years[i];
                for (int j=0; j < codes.length; j++){
                    double dd = World.calc_mean_prices(codes[j])[i];
                    if (! Double.isNaN(dd)){
                        row[j+2] = String.format("%.2f",World.calc_mean_prices(codes[j])[i]);
                    }
                    else{
                        row[j+2] = "";
                    }
                    
                }

                model.addRow(row);
            }
        }
    }
    
    // </editor-fold> 
    
    // <editor-fold defaultstate="collapsed" desc="TabbedPane functions">
    private void updateIntFrameMeanPrices(){
        // для отображения данных World
        jTabbedPane1.removeAll();
        
        LineChart chart = new LineChart("", "Год", "Цена, доллары");
        String[] names = {"ПК","ЕРР", "ОУП","МОКС"}; //};
        short[] codes = {Contract.P_PK,Contract.P_SWU,Contract.P_OUP, Contract.P_MOX}; //, };
        for (int i=0; i < codes.length; i++){
            chart.addData(names[i], Time.years, World.calc_mean_prices(codes[i]));
        }

        chart.run(jTabbedPane1.getSize());

        jTabbedPane1.addTab("Средняя стоимость", chart);
        
//        jTabbedPane1.updateUI();
    }
    
    private void addSingleMeanPrices(){
        // добавляет графики по всем типам в отдельности
        
        // сначала добавим общий график
        updateIntFrameMeanPrices();
        
        // а теперь каждый в отдельности
        String[] names = {"ПК","ЕРР", "ОУП","МОКС"}; //};
        short[] codes = {Contract.P_PK,Contract.P_SWU,Contract.P_OUP, Contract.P_MOX}; //, };
        
        for (int i=0; i < names.length; i++){
            LineChart chart = new LineChart("", "Год", "Цена, доллары");   
            chart.addData(names[i], Time.years, World.calc_mean_prices(codes[i]));
            chart.run(jTabbedPane1.getSize());

            jTabbedPane1.addTab(names[i], chart);
//            jTabbedPane1.updateUI();
        } 
    }
    
    private void updateIntFrameDemands(){
        // для отображения данных World
        jTabbedPane1.removeAll();
        
        LineChart chart = new LineChart("", "Год", "Объем");
        //String[] names = {, , ,"МОКС"};
        short[] codes = {Contract.P_PK,Contract.P_SWU,Contract.P_OUP, Contract.P_MOX}; //};
        
        chart.addData("ПК",Time.years, World.total_pk_demand);
        chart.addData("ЕРР",Time.years, World.total_swu_demand);
        chart.addData("ОУП", Time.years,World.total_eup_demand);
        chart.addData("МОКС", Time.years,World.total_mox_demand);

        chart.run(jTabbedPane1.getSize());

        jTabbedPane1.addTab("Совокупный спрос", chart);
        
//        jTabbedPane1.updateUI();
    }
    
    private void addSingleDemands(){
        // добавляет графики по всем типам в отдельности
        
        // сначала добавим общий график
        updateIntFrameDemands();
        
        // а теперь каждый в отдельности
        String[] names = {"ПК","ЕРР", "ОУП","МОКС"}; //};
        short[] codes = {Contract.P_PK,Contract.P_SWU,Contract.P_OUP, Contract.P_MOX}; //};
        
        for (int i=0; i < names.length; i++){
            double[] demand = new double[1];
            if (names[i].equals("ПК")){
                demand = World.total_pk_demand;
            }
            else if (names[i].equals("ОУП")){
                demand = World.total_eup_demand;
            }
            else if (names[i].equals("ЕРР")){
                demand = World.total_swu_demand;
            }
            else if (names[i].equals("МОКС")){
                demand = World.total_mox_demand;
            }
            
            try{
                LineChart chart = new LineChart("", "Год", "Объем");   
                chart.addData(names[i],Time.years, demand);
                chart.run(jTabbedPane1.getSize());

                jTabbedPane1.addTab(names[i], chart);
    //            jTabbedPane1.updateUI();
            }
            catch(Exception e){
                throw new RuntimeException("Wrong type in creating charts");
            }
        } 
    }
    
    private void updateIntFrameSupply(){
        // для отображения данных World
        jTabbedPane1.removeAll();
        
        LineChart chart = new LineChart("", "Год", "Объем");
        //String[] names = {, , "ОУП","МОКС"};
        short[] codes = {Contract.P_PK,Contract.P_SWU}; //,Contract.P_OUP, Contract.P_MOX};

        chart.addData("ПК",Time.years, World.total_pk_supply);
        chart.addData("ЕРР", Time.years,World.total_swu_supply);
        chart.addData("МОКС", Time.years,World.total_mox_supply);
        
        chart.run(jTabbedPane1.getSize());

        jTabbedPane1.addTab("Совокупное предложение", chart);
        
//        jTabbedPane1.updateUI();
    }    
    
    private void addSingleSupply(){
        // добавляет графики по всем типам в отдельности
        
        // сначала добавим общий график
        updateIntFrameSupply();
        
        // а теперь каждый в отдельности
        String[] names = {"ПК","ЕРР","МОКС"}; //, "ОУП",};
        short[] codes = {Contract.P_PK,Contract.P_OUP, Contract.P_MOX}; //,Contract.P_SWU, };
        
        for (int i=0; i < names.length; i++){
            double[] demand = new double[1];
            if (names[i].equals("ПК")){
                demand = World.total_pk_supply;
            }
            else if (names[i].equals("ЕРР")){
                demand = World.total_swu_supply;
            }
            else if (names[i].equals("ОУП")){
                // у ОУПа нет предл-я, поэтому этот вариант не рассматриваем
            }
            else if (names[i].equals("МОКС")){
                demand = World.total_mox_supply;
            }
            
            try{
                LineChart chart = new LineChart("", "Год", "Объем");  
                chart.addData(names[i], Time.years,demand);
                chart.run(jTabbedPane1.getSize());

                jTabbedPane1.addTab(names[i], chart);
    //            jTabbedPane1.updateUI();
            }
            catch(Exception e){
                throw new RuntimeException("Wrong type in creating charts");
            }
        } 
    }
    
    private void updateIntFrame(Contract cont){
        // для отображения данных по контракту
    }
    
    private void clearIntFrame(){
//        jDesktopPane1.removeAll();
//        jDesktopPane1.updateUI();
    }
    
    // </editor-fold> 

    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        if (this.jRadioButton1.isSelected()){
            if (! this.jTextArea1.getText().equalsIgnoreCase("")){
                this.buffer_local = this.jTextArea1.getText();
            }
            if (this.dg_actor_prop.isVisible()){
                this.dg_actor_prop.setVisible(false);
                this.is_visible = true;
            }
                
            String msg = "Добро пожаловать в Мир!";

            msg += "\n\nПриродное обогащение = " + String.valueOf(World.natural_enrichment);
            msg += "\nХвосты обогащения = " + String.valueOf(World.waste_enrichment);
            msg += "\nОбщее количество реакторов = " + String.valueOf(World.calc_all_reactor(dm1.my_operators));
            msg += "\nКоличество активных реакторов = " + String.valueOf(World.calc_current_reactor(dm1.my_operators));

            this.jTextArea1.setText(msg);
            this.jTextArea1.append("trst");
            //jTextArea2.setText("");
            this.buffer_world = "";
            
            //jTable1.setVisible(false);
            
            clearTable(this.jTable2);
            updateTable();
        }
        else{
            if (! this.jTextArea1.getText().equalsIgnoreCase("")){
                this.buffer_world = this.jTextArea1.getText();
            }
            this.jTextArea1.setText(this.buffer_local);
            
            if (is_visible){
                this.dg_actor_prop.setVisible(true);
                //jTextArea2.setText(buffer_properties);
                //jTable1.setVisible(true);
            }
            
            clearTable(this.jTable2);
            jTabbedPane1.removeAll();
            this.jButton9.setEnabled(false);
        }
    }//GEN-LAST:event_jRadioButton1ActionPerformed

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
        // отображение графиков по-отдельности
        String item = String.valueOf(jComboBox1.getSelectedItem());

        if (item.equals("Совокупный спрос")){
            addSingleDemands();
        }
        else if (item.equals("Совокупный предл-е")){
            addSingleSupply();
        }
        else if (item.equals("Средняя стоимость")){
            addSingleMeanPrices();
        }
        this.jButton9.setEnabled(true);
    }//GEN-LAST:event_jButton9ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
/*
        Object[] possibilities = {"ham", "spam", "yam"};
        String s = (String)JOptionPane.showInputDialog(
                    this,
                    "Введите новое значение:",
                    "Установить значение",
                    JOptionPane.PLAIN_MESSAGE, new ImageIcon("write_changes.png"),
                    null,
                    World.waste_enrichment);

        //If a string was returned, say so.
        if ((s != null) && (s.length() > 0)) {
            jTextArea1.append("\nWaste enrichment changed: " + s);  //TODO: сделать реальное изменение
            return;
        }
*/
    }//GEN-LAST:event_jButton5ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTree jTree1;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
}
