/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author z
 */
public class DemoGuiOperatorProperties extends javax.swing.JFrame {

    private String EXCEL_FILE = "example_actors.xlsx";    // TODO: изменить?
    private String EXCEL_FILE_PATH = "./" + EXCEL_FILE; 
    
    private JTree jTree1;
   
    private Operator participant;
    private String actor_name;      // последний выбранный в дереве актор

    public DemoGuiOperatorProperties(JTree tree) {
        initComponents();
         
        this.jTree1 = tree;
        
        setupButtonGroup();

    }

    private void setupButtonGroup(){
        ButtonGroup buttonGroup = new ButtonGroup();
        buttonGroup.add(jRadioButton1);
        buttonGroup.add(jRadioButton2);
        buttonGroup.add(jRadioButton3);
        buttonGroup.add(jRadioButton4);
        jRadioButton1.setSelected(false);
        jRadioButton2.setSelected(false);
        jRadioButton3.setSelected(false);
        jRadioButton4.setSelected(false);
        
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton5 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList<>();
        jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton4 = new javax.swing.JRadioButton();
        jButton9 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jRadioButton5 = new javax.swing.JRadioButton();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setLocation(new java.awt.Point(1050, 0));
        setResizable(false);

        jButton5.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton5.setText("Статистика участника");
        jButton5.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Список контрактов:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(675, 150));

        jScrollPane4.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane4.setPreferredSize(new java.awt.Dimension(346, 90));

        jList1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jList1.setModel(new DefaultListModel());
        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jList1.setCellRenderer(new DefaultListCellRenderer() {
            public java.awt.Component getListCellRendererComponent(JList list,
                Object value, int index, boolean isSelected,
                boolean cellHasFocus) {
                //                Contract cont = (Contract)value;
                //                setText(String.valueOf(cont.id));
                //                setIcon(new javax.swing.ImageIcon("/contract-icon.png"));
                //                setFont(list.getFont()); 
                //                setOpaque(true); 
                //                return this;
                java.awt.Component component = super.getListCellRendererComponent(list,
                    value, index, isSelected, cellHasFocus);
                ((javax.swing.JLabel) component).setIcon(new javax.swing.ImageIcon("src/contract-icon.png"));
                ((javax.swing.JLabel) component).setText(String.valueOf(((Contract)value).id));
                ((javax.swing.JLabel) component).setHorizontalTextPosition(CENTER);
                ((javax.swing.JLabel) component).setVerticalTextPosition(BOTTOM);
                ((javax.swing.JLabel) component).setFont(list.getFont());
                //((javax.swing.JLabel) component).set
                return component;
            }
        });
        jList1.setLayoutOrientation(javax.swing.JList.HORIZONTAL_WRAP);
        jList1.setPreferredSize(new java.awt.Dimension(663, 119));
        jList1.setVisibleRowCount(1);
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane4.setViewportView(jList1);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Описание:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(675, 569));

        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTextArea2.setRows(5);
        jTextArea2.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jTextArea2.setEnabled(false);
        jTextArea2.setPreferredSize(new java.awt.Dimension(255, 537));
        jScrollPane2.setViewportView(jTextArea2);

        jTable1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Год", "Мощность", "Число реакторов"
            }
        ));
        jTable1.setPreferredSize(new java.awt.Dimension(372, 537));
        jScrollPane6.setViewportView(jTable1);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Схема торгов", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N

        jRadioButton1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton1.setText("ПК");

        jRadioButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton2.setText("ОУП");

        jRadioButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton3.setText("ЕРР+ПК");

        jRadioButton4.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton4.setText("МОКС");

        jButton9.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton9.setText("Установить схему");
        jButton9.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        jScrollPane1.setBorder(null);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);

        jTextArea1.setEditable(false);
        jTextArea1.setBackground(new java.awt.Color(240, 240, 240));
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setText("Текущее значение: " + "отсутствует");
        jScrollPane1.setViewportView(jTextArea1);

        jRadioButton5.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton5.setText("МОКС для PWR");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jRadioButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jRadioButton3))
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButton9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                .addGap(30, 30, 30)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel3Layout.createSequentialGroup()
                                        .addComponent(jRadioButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jRadioButton5))
                                    .addGroup(jPanel3Layout.createSequentialGroup()
                                        .addComponent(jRadioButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(0, 0, Short.MAX_VALUE)))))))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(27, 27, 27)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton1)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton3)
                    .addComponent(jRadioButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane6)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 306, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButton7.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton7.setText("Сохранить статистику");
        jButton7.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jButton8.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton8.setText("Добавить реактор");
        jButton8.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 862, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 862, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(49, 49, 49)
                        .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(47, 47, 47)
                        .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 1, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    // <editor-fold defaultstate="collapsed" desc="jTable functions">
    private void createTableOperator(Operator actor){
         
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        
        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        Object[] row = new Object[model.getColumnCount()];
        
        for (int i=0; i < Time.years.length; i++){       //actor.all_capacity.length
            row[0] = Time.years[i];
            row[1] = actor.stats.getElectric_capcity()[i];
            row[2] = actor.stats.getReactors()[i];
            
            model.addRow(row);
        }
    }
    
    private void clearTable(javax.swing.JTable table){
        DefaultTableModel model = (DefaultTableModel) table.getModel();
        
        if (! model.getDataVector().isEmpty()){
            model.getDataVector().removeAllElements();
        }
        
        table.updateUI();

    }
    
    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // Show contracts list

            
        (new DemoGuiOperatorStatistics((Operator)this.participant)).setVisible(true);

        DefaultListModel listModel = (DefaultListModel) jList1.getModel();
        listModel.removeAllElements();

        for (int i=0; i < ContractChain.getContracts().size(); i++){ 
            //System.out.println(String.valueOf(ContractChain.getContracts().get(i).get_current_owner().getName().equals(this.actor_name)));
            if (ContractChain.getContracts().get(i).get_current_owner().getName().equals(this.actor_name)){
                listModel.addElement(ContractChain.getContracts().get(i));              
            }            
        }
        
        //jList1.setModel(listModel);
    }//GEN-LAST:event_jButton5ActionPerformed
//</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="jList functions">
    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        Contract selectedValue = (Contract)((JList)evt.getSource()).getSelectedValue();
        printContractInfo(selectedValue); 
        //jList1.updateUI();
        //DefaultListModel listModel = (DefaultListModel) jList1.getModel();
        jList1.getSelectionModel().removeSelectionInterval(1,1); // или пробуй jList1.clearSelection()
    }//GEN-LAST:event_jList1ValueChanged

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // export to excel
        try {
            
            Function<Operator, LinkedHashMap> func = (actor)-> actor.getStats().assembleOperatorSet();
            ExcelLoader<Operator> el = new ExcelLoader<>(EXCEL_FILE_PATH);
            el.writeIntoExcel((Operator) this.participant, func, "Оператор "+actor_name);
            
            JOptionPane.showMessageDialog(new JPanel(),"Сохранено", "Готово!",
                    JOptionPane.INFORMATION_MESSAGE);
        }
        catch (IOException ex) {
            Logger.getLogger(DemoGuiArchive.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButton7ActionPerformed

    public void addReactor(Reactor reac){
        this.participant.addReactor(reac);

    }
    
    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        // add new reactot

        DemoGuiReactorCreate module = new DemoGuiReactorCreate(this.participant.getRegion());
        module.setVisible(true);
        module.addWindowListener(new WindowListener(){
            @Override
            public void windowClosed(WindowEvent e) {
                addReactor(((DemoGuiReactorCreate)e.getSource()).getReactor());
            }

            @Override
            public void windowActivated(WindowEvent e) {}

            @Override
            public void windowOpened(WindowEvent e) {}

            @Override
            public void windowClosing(WindowEvent e) {}

            @Override
            public void windowIconified(WindowEvent e) {}

            @Override
            public void windowDeiconified(WindowEvent e) {}

            @Override
            public void windowDeactivated(WindowEvent e) {}
        });
        
    }//GEN-LAST:event_jButton8ActionPerformed

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
        int i;
        if (jRadioButton2.isSelected()){
           i = Contract.EUP;
        } else{
            if (jRadioButton3.isSelected()){
                i = Contract.SWU_PK;
            } else{
                if (jRadioButton4.isSelected()){
                    i = Contract.MOX;
                }else{
                    return;
                    }
            }
        }
        ArrayList<Reactor> all_reacs = participant.get_reactors();
        for (Reactor reac : all_reacs) {
            reac.set_type(i);
        }
    }//GEN-LAST:event_jButton9ActionPerformed

    private void printContractInfo(Contract selectedContract){
        try{
            jTextArea2.setText("");
            String msg = "Контракт "+selectedContract.id+"\n\n";
            jTextArea2.append(msg);
            msg = "Покупатель: "+ selectedContract.get_buyer().getName() + "\n";
            jTextArea2.append(msg);
            msg = "Продавец: "+ selectedContract.get_seller().getName() + "\n";
            jTextArea2.append(msg);
            msg = "Продукт: "+ selectedContract.get_product() + "\n";
            jTextArea2.append(msg);
            msg = "Объем: "+ String.format("%.2f", selectedContract.volume) + "\n";
            jTextArea2.append(msg);
            msg = "Стоимость = "+ String.format("%.2f", selectedContract.price) + "\n";
            jTextArea2.append(msg);
            msg = "Год сделки: "+ String.valueOf(selectedContract.year) + "\n";
            msg += "Год доставки: "+ String.valueOf(selectedContract.year) + "\n";

            jTextArea2.append(msg); 
        }
        catch (java.lang.NullPointerException e){
            jTextArea2.setText("NULLLLLL");
       }
    }

    private void clearList(){
        DefaultListModel listModel = (DefaultListModel) this.jList1.getModel();
        listModel.removeAllElements();
    }
//</editor-fold>
       
    // <editor-fold defaultstate="collapsed" desc="Public functions for managing">
    /*
    Here are a couple functions for adding text to JTextArea2
    and functions for Frame updating.
    Algorithm of updating:
    1) clear List, Table;
    2) assignment args to private  fields;
    3) fill jTextArea & Table (call output* function).
    */
 
    public void setText(String msg){
        this.jTextArea2.setText(msg);
    }
    
    public void appendText(String msg){
        this.jTextArea2.append(msg);
    }
    
        
    private void outputOperator(Operator actor){
        String msg = "Оператор "+ actor.getName() + ":\n\n";
        msg += "Агент: "+ actor.getAgent().getName()+ "\n";
        msg += "Регион: " + actor.getRegion().name;
        msg += "\nДенежные средства = " + String.format("%.2f", actor.money);

        //<editor-fold defaultstate="collapsed" desc="Code for reactors">
//        msg += "\n\nРеакторы:";
//        for (int j=0; j < actor.reactors.size(); j++){
//            msg += "\n\n"+actor.reactors.get(j).name + "   -   ";
//            msg += actor.reactors.get(j).Rclass;
//            msg += "\nЭлектрическая мощность = " + actor.reactors.get(j).electrical_capacity;
//            msg += "\nТермическая мощность = " + actor.reactors.get(j).termal_capacity;
//            msg += "\nСтатус: " + actor.reactors.get(j).status;
//            msg += "\nКИУМ = " + actor.reactors.get(j).eaf;
//            msg += "\nПотребности: " + "not supported yet";//actor.reactors.get(j).;
//            msg += "\nКоэффициент выгорания: " + actor.reactors.get(j).burnup;
//            
//        }
//</editor-fold>
        
        jTextArea2.setText(msg);
       
    }
    
    // активация какой-то кнопки в зависимости от типа
    private void activateRadioButton(){
        ArrayList<Reactor> all_reacs = participant.get_reactors();
        int t = all_reacs.get(0).getType();
        for (int i=1; i < all_reacs.size(); i++) {
            if (t != all_reacs.get(i).getType()){
                t = -1;
                break;
            }
        }
    
        if (t < 0){
            jTextArea1.setText("Выбрано несколько схем");
        }
        else{
            switch (t){
                case 1:
                    jRadioButton2.setSelected(true);
                    break;
                case 2:
                    jRadioButton1.setSelected(true);
                    break;
                case 3:
                    jRadioButton3.setSelected(true);
                    break;
                case 4:
                    jRadioButton4.setSelected(true);
                    break;
                default:
                    break;
            }
        }
}

    
    // если класс неверный
    public void update_UI(String msg){
        clearList();
        clearTable(this.jTable1);
        
        this.jTextArea2.setText(msg);
    }

    // если выбран оператор
    public void update_UI(Operator op, String op_name){
        clearList();
        clearTable(this.jTable1);
        
        this.participant = op;
        this.actor_name = op_name;
        
        activateRadioButton();
        outputOperator(op);
        createTableOperator(op);
        op.stats.assembleOperatorSet();
    }
    
 // </editor-fold>    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JList<String> jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JRadioButton jRadioButton5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    // End of variables declaration//GEN-END:variables
}
