/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import Graphic.LineChart;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.function.Function;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author z
 */
public class DemoGuiRegionProperties extends javax.swing.JFrame {
 
    private Region participant;
    private String country_name;      // последняя выбранная в дереве страна


    public DemoGuiRegionProperties(){
        initComponents();
    }
    
    public DemoGuiRegionProperties(Region c) {
        initComponents();
   
        this.participant = c;
        this.country_name = c.getName();
        outputRegion(participant);
        createTabbedPane();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setLocation(new java.awt.Point(1000, 0));
        setResizable(false);

        jScrollPane1.setBorder(null);
        jScrollPane1.setForeground(new java.awt.Color(240, 240, 240));
        jScrollPane1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N

        jTextArea1.setEditable(false);
        jTextArea1.setBackground(new java.awt.Color(240, 240, 240));
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);
        jTextArea1.setLineWrap(true);
        jTextArea1.setWrapStyleWord(true);

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(572, 342));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 530, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane1)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    //</editor-fold>
    

       
    // <editor-fold defaultstate="collapsed" desc="Properties output">

    private void outputRegion(Region selected){
        try{
            jTextArea1.setText("");
            String msg = "Регион: "+ selected.getName() + "\n";
            jTextArea1.append(msg);

        }
        catch (java.lang.NullPointerException e){
            jTextArea1.setText("NULLLLLL");
       }
    }
    

    //private void showChart(String chart_name, String title, String x_label, int[] x_data, String y_label, Operator op, Function<Operator,double[]> func)
    private void createTabbedPane(){
               
        jTabbedPane1.removeAll();
        
        try{
            // кол-во рекаторов
            double[] hm = assemble_data("reactors");
           jTabbedPane1.addTab("Кол-во рекаторов", createChart(this.jTabbedPane1, "", "", "Год", Time.years, "", hm));
           jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);

           // электрическая мощность
           hm = assemble_data("electric_capcity");
           jTabbedPane1.addTab("Электрическая мощность", createChart(this.jTabbedPane1, "", "", "Год", Time.years, "", hm));
           jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);

            // производство электричества
            hm = assemble_data("electrcity");
           jTabbedPane1.addTab("Производство электричества", createChart(this.jTabbedPane1, "", "", "Год", Time.years, "", hm));
           jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);
        }
        catch(IOException e){
            e.printStackTrace();
        }
    }
    
    // type: "reactors", "electric_capcity" or "electrcity"
    private double[] assemble_data(String type) throws IOException{
        ArrayList<Region> regions = World.tbulletin.my_regions;
        ArrayList<Operator> operators = World.tbulletin.my_operators;

            String region = this.participant.getName();
            Object[] opos = operators.stream().filter(a -> a.getRegion().equals(region)).toArray();
            ArrayList<Operator> ops = new ArrayList();
            for (Object opo : opos) {
                ops.add((Operator) opo);
            }

            double[] resultMap = (double[]) Statistic.agregateOperator(ops).get(type);

        
        return resultMap;
    }
    
    private LineChart createChart(java.awt.Component component, String chart_name, String title, String x_label, int[] x_data, String y_label, double[] y_data){
        LineChart chart = new LineChart(chart_name, x_label, y_label);  
        chart.addData(title, x_data, y_data);
        chart.run(component.getSize());
        return chart;
    }

 // </editor-fold> 
    
    // <editor-fold defaultstate="collapsed" desc="Public functions for managing">
    /*
    Here are a couple functions for adding text to JTextArea2
    and functions for Frame updating.
    Algorithm of updating:
    1) clear Table;
    2) assignment args to private  fields;
    3) fill jTextAreas & Table (call output* function).
    */
 
    // если класс неверный
    public void update_UI(String msg){

        this.jTextArea1.setText(msg);
    }
    
    // для реакторв
    public void update_UI(Region r, String coun_name){

        this.participant = r;
        this.country_name = coun_name;
        
        outputRegion(r);
    }
   
 // </editor-fold>    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
}
