/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;


/**
 *
 * @author Dmitry
 */
public class MoxSupplier extends Producer{
    MoxMargeFuzzyCalculator MargeFuzzyCalculator;
    MoxDiscountFuzzyCalculator DiscountFuzzyCalculator;
    
    double costStorage = 0.230;
    double costRecycling = 0.7;
    double costFabrication = 0.3;

    public MoxSupplier(double capacity, double cost, double[] all_capacity, double[] all_cost) {
        super();
        this.capacity = capacity;
        this.cost = cost;
        this.all_capacity = all_capacity;
        this.all_cost = all_cost;
        MargeFuzzyCalculator = new MoxMargeFuzzyCalculator(this);
        DiscountFuzzyCalculator = new MoxDiscountFuzzyCalculator(this);
    }


    @Override
    void deal_mox(Contract c) {
        capacity = capacity - c.volume;
        money = money + c.price*c.volume;
        Agreement aa = Agreement.create_agreement(c);
        sales.get(c.year).add(aa);
        stats.recalc_deals_stat(c.year, c.product);
    }
    
    @Override
    boolean check_capacity(double volume) {
        return this.capacity > volume; //To change body of generated methods, choose Tools | Templates.
    }

    double calc_price(Contract c) {
        double marge = c.get_seller().calc_marge(c); 
        c.setMin_price((costStorage + costRecycling + costFabrication)*(1+min_marge));
        double price = (costStorage + costRecycling + costFabrication)*(1+marge);
        return price;
    }
    
    @Override
    double calc_marge(Contract c) {
        double marge = MargeFuzzyCalculator.calc_marge(c);
        c.setMarge(marge);
        return marge;
        
    }


    @Override
    double calc_discount(Contract c) {
        return DiscountFuzzyCalculator.calc_discount(c);
    }

    
}
