/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

/**
 *
 * @author Dmitry
 */
public class Producer extends Actor{
    double capacity;
    double cost;
    double[] all_capacity;
    double[] all_cost;
    double loaded = 0;
    double resources = 0;
    int pbase = PBASE_COST;
    double min_marge = 0.15;
    
    static int PBASE_COST = 0;
    static int PBASE_PRICE = 1;
    
    
    @Override
    boolean is_capable(double volume) {
        return capacity >= volume; 
    }

    @Override
    boolean is_capable(Contract c) {
        return capacity >= c.volume;
    }
    double calc_price(ContractSWUPK c){
        throw new UnsupportedOperationException("Реализация в подклассе");
    }
    
    
    @Override 
    double calc_price(Contract c) {
        double marge = calc_marge(c); 
        double price;
        if (pbase == PBASE_COST){
            price = cost*(1+marge);
            c.setMin_price(cost*(1+min_marge));
        }else{
            switch(c.product){
                case Contract.P_MOX: {
                   price = World.spotMOXprice[Time.iTime];
                   break;
                }
                case Contract.P_OUP: {
                   price = World.spotEUPprice[Time.iTime];break;
                }
                case Contract.P_PK: {
                   price = World.spotPKprice[Time.iTime];break;
                }
                case Contract.P_SWU: {
                   price = World.spotSWUprice[Time.iTime];break;
                }
                default: throw new Error("not found product");
            }
            c.setMin_price(price*0.8);
            price = price*(1+marge);

        }
        return price;
    } 
    
    @Override
    double calc_marge(Contract c) {
        double marge = Math.random()*0.3;
        return marge;
    }
    @Override
    double calc_marge(ContractSWUPK c) {
        double marge = Math.random()*0.3;
        return marge;
    }
    @Override
    double calc_discount(Contract c) {
        
        return Math.random()*0.1; //To change body of generated methods, choose Tools | Templates.
    }
    
    void increase_capacity(double V){
        capacity = capacity + V;
    }
    
    void setCapacity(double new_capacity, int ind){
        this.all_capacity[ind] = new_capacity;
    }
    
    void setCost(double new_cost, int ind){
        this.all_cost[ind] = new_cost;
    }
    
    void setPbase(int ind){
        switch (ind){
            case 0:
                this.pbase = PBASE_COST;
                break;
            case 1:
                this.pbase = PBASE_PRICE;
                break;
            default:
                System.out.println("Set pbase: wrong index");
                break;
        }
    }
    
    public int getPbase(){
        return this.pbase;
    }
    
    public double getCapacity(){
        return this.capacity;
    }
        
    public double getCost(){
        return this.cost;
    }
    
    public double getMinMarge(){
        return this.min_marge;
    }
    
    public void setMinMarge(double mm){
        this.min_marge = mm;
    }

    public void setMin_marge(double min_marge) {
        this.min_marge = min_marge;
    }
    
    
    @Override
    void restore() {
        if(Time.iTime < (Time.lastTime-1)){
            this.capacity = all_capacity[Time.iTime];
            this.cost = all_cost[Time.iTime];
            }
    }
}
