/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class Tender {

Contract c;
TradeBulletin tbulletin;
static boolean LOGGING = false;
    
    static void set_tender(Contract new_contract) {
        switch (new_contract.type){
            case Contract.SWU_PK: new_contract.set_tender(new TenderSWU());break;
            case Contract.EUP: {
                if (new_contract.product == Contract.P_OUP){
                    new_contract.set_tender(new TenderEUPSolo());
                    break;
                } else
                    if (new_contract.product == Contract.P_PK){
                        new_contract.set_tender(new TenderPK());
                        break;
                    }
            }
            case Contract.MOX: new_contract.set_tender(new TenderMOX());break;
            case Contract.PK_Solo: new_contract.set_tender(new TenderPKSolo());break;
            case Contract.REMIX: new_contract.set_tender(new TenderRemix());break;
        }
    }
    
    static boolean is_any_level(short Level, ArrayList<Contract> cons){
        boolean[] is_L = new boolean[cons.size()];
        int i = 0;
        for (Contract con : cons) {
            short level = con.level;
            is_L[i] = level == Level;
            i++;
        }
        return Arithmetic.any(is_L);
    }
    
    static boolean is_all_level(short Level, ArrayList<Contract> cons){
        boolean[] is_L = new boolean[cons.size()];
        int i = 0;
        for (Contract con : cons) {
            short level = con.level;
            is_L[i] = level == Level;
            i++;
        }
        return Arithmetic.all(is_L);
    }
    
     Tender() {
        
    }

    void set_contract(Contract con) {
        this.c = con;
    }

    void set_tbulletin(TradeBulletin tbulletin) {
        this.tbulletin = tbulletin;
    }

    void tick() {
        switch (c.level){
            case Contract.LEVEL_A: operate_contract_A();break;
            case Contract.LEVEL_B: operate_contract_B();break;
            case Contract.LEVEL_C: operate_contract_C();break;
            case Contract.LEVEL_D: operate_contract_D();break;
            case Contract.LEVEL_F: operate_contract_F();break;
            case Contract.LEVEL_H: operate_contract_H();break;
            case Contract.LEVEL_R: operate_contract_R();break;
            case Contract.LEVEL_W: operate_contract_W();break;
        }
    }

    void operate_contract_A() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_C() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_B() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_D() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_F() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_H() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void operate_contract_R() {
        
    }

    void operate_contract_W() {
        // Проверить нет ли отмененных родственников
       /* if ( !c.getSons().isEmpty()){
            if (c.getSon(0).level == Contract.LEVEL_RR){
                c.level = Contract.LEVEL_R;
                c.getSon(0).level = Contract.LEVEL_R;
                return;
            }
        }
        if ( c.getFather() != null){
            if (c.getFather().level == Contract.LEVEL_RR){
                c.level = Contract.LEVEL_R;
                c.getFather().level = Contract.LEVEL_R;
            }
        }
        */
    }
    
    boolean consider_deal(double prioritet){
        
        // Если приемлимо заключается контракт
         // Если нет проверить стадию торгов и дату поставки
         // В заисимости от проверки отправить на досогласование, принять или прекраить торги
        if (this.c.get_buyer().is_acceptаble(prioritet) && this.c.get_seller().is_capable(c) && !c.get_buyer().check_quota(c)){
            // Заключить сделку
            this.c.get_buyer().deal(c);
            this.c.get_seller().deal(c);
            c.set_current_owner(c.get_buyer());
            ArchiveChain.add(c);
            c.level = Contract.LEVEL_H;
            return true;
         }
         else{
            if (! this.c.get_seller().is_capable(c) || c.get_buyer().check_quota(c)){
                c.level = Contract.LEVEL_R;
                operate_contract_R();
                if (Tender.LOGGING)
                System.err.println("Contract " + c.id + " set to level R");
            }
            else{
                c.level = Contract.LEVEL_C;
                c.set_current_owner(c.get_seller());
            }
            return false;
         }
    
    }
    
    boolean can_consider_deal(double prioritet){
        return this.c.get_buyer().is_acceptаble(prioritet) && this.c.get_seller().is_capable(c);
    }
    
    
    void go_to_seller(){
        if(c.level != Contract.LEVEL_R){
            c.level = Contract.LEVEL_C;
            c.set_current_owner(c.get_seller());
        }
    }

    void cancel() {
        c.level = Contract.LEVEL_R;
        operate_contract_R();
    }
    void check_Rsons() {
        ArrayList<Contract> sons = c.getAllSons();
        if (sons.isEmpty()){
            throw new Error("We have sonless father here!");
        }
        if(Tender.is_all_level(Contract.LEVEL_R, sons)){
            c.level = Contract.LEVEL_R;
            if(c.reason==0)
            c.reason = Contract.REASON_PK_YOK;
        }
    }
    
    void waitC(){
       c.level = Contract.LEVEL_W; 
    }
    
    void check_priority(Contract W) {
        if (W.get_buyer().is_acceptаble(W) & !W.get_buyer().is_acceptаble(W.historic_prioritet.lastElement())){
            W.historic_prioritet.set(W.historic_prioritet.lastIndexOf(W.historic_prioritet.lastElement()), W.get_buyer().threshold);
        }
    }
    
    void check_priority(ContractSWUPK W) {
        if (W.get_buyer().is_acceptаble(W) & !W.get_buyer().is_acceptаble(W.historic_prioritet.lastElement())){
            W.historic_prioritet.set(W.historic_prioritet.lastIndexOf(W.historic_prioritet.lastElement()), W.get_buyer().threshold);
        }
    }
    
    void set_price() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void wake_up() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    void set_discount(){
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    void setMarge(double marge) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    
}
