/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;

/**
 *
 * @author Dima
 */
public class TenderPK extends Tender {

    @Override
    void operate_contract_A() {
        // проверить выполнимость
        if (this.c.get_seller().is_capable(c.volume)){
            c.level = Contract.LEVEL_B;
            double price = c.get_seller().calc_price(c);
            c.set_price(price);
            c.set_current_owner(c.get_buyer());
        } else {
            c.level = Contract.LEVEL_R;
            c.getFather().check_RSons();
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level A");
    }

    @Override
    void operate_contract_B() {
        // Обогатитель получает ответы от B контрактов шахтера
        // можно сформировать цену контракта на ОУП и отправить оператору
        // Параллельно посчитаем еще и приоритеты для шахт, чтобы потом не считать, но отправлять обратно пока не будем
        ArrayList<Contract> pk_contracts;
        try {
            pk_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
        
        
         pk_contracts.add(this.c);
         double[] prioritets = new double[pk_contracts.size()];
         int i=0;
         for (Contract pk_brothre : pk_contracts) {
            prioritets[i] = pk_brothre.get_buyer().calc_prioritet(pk_brothre);
            pk_brothre.historic_price.add(pk_brothre.price);
            pk_brothre.historic_prioritet.add(prioritets[i]);
            pk_brothre.level = Contract.LEVEL_W;
            pk_brothre.set_current_owner(c.get_buyer());
            i++;
        }
        pk_contracts.get(0).getFather().wake_up();
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level B");
    }

    @Override
    void operate_contract_C() {
        if (! c.get_seller().is_capable(c.volume)) {
            c.level = Contract.LEVEL_R;
            c.getFather().check_RSons();
        } else{
            //double discount = c.get_seller().calc_discount(c);
            double new_price = c.get_seller().set_discount_price(c);
                    
            if (new_price < c.min_price){new_price = c.min_price;}   
            c.set_price(new_price);
            c.historic_price.add(new_price);
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level C");
    }
    
    
    
    @Override
    void operate_contract_D() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            ac_brothre.level = Contract.LEVEL_W;
            i++;
        }
        ac_contracts.get(0).getFather().wake_up();
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level D");
    }

    @Override
    void operate_contract_R() {
        c.getFather().check_RSons();
    }
    
    
    
    @Override
    void wake_up() {
       c.level = Contract.LEVEL_C; 
    }
    
    
}
